# Copyright INRA/CNRS
# 
# Emmanuel.Courcelle@toulouse.inra.fr
# Sebastien.Carrere@toulouse.inra.fr
# 
# Ce logiciel est un programme informatique servant à [rappeler les
# caractéristiques techniques de votre logiciel]. 
# 
# Ce logiciel est régi par la licence [CeCILL|CeCILL-B|CeCILL-C] soumise au droit français et
# respectant les principes de diffusion des logiciels libres. Vous pouvez
# utiliser, modifier et/ou redistribuer ce programme sous les conditions
# de la licence [CeCILL|CeCILL-B|CeCILL-C] telle que diffusée par le CEA, le CNRS et l'INRIA 
# sur le site "http://www.cecill.info".
# 
# En contrepartie de l'accessibilité au code source et des droits de copie,
# de modification et de redistribution accordés par cette licence, il n'est
# offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
# seule une responsabilité restreinte pèse sur l'auteur du programme,  le
# titulaire des droits patrimoniaux et les concédants successifs.
# 
# A cet égard  l'attention de l'utilisateur est attirée sur les risques
# associés au chargement,  à l'utilisation,  à la modification et/ou au
# développement et à la reproduction du logiciel par l'utilisateur étant 
# donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
# manipuler et qui le réserve donc à des développeurs et des professionnels
# avertis possédant  des  connaissances  informatiques approfondies.  Les
# utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
# logiciel à leurs besoins dans des conditions permettant d'assurer la
# sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
# à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 
# 
# Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
# pris connaissance de la licence [CeCILL|CeCILL-B|CeCILL-C], et que vous en avez accepté les
# termes.

package DisplayField::CaracterepField;

use strict;
use WebBuilder;

use O2DBI::O2DBI_WebUtils;
use O2DBI::DisplayField;
use base qw(DisplayField);
use clism::DBMS;
use clism::gene;
use MIME::Base64;

=head2 Fonction GetTableHtmlDelete
 Title    : GetTableHtmlDelete
 Usage    : Pour utiliser a partir de AnotherTemplate
 Function : Renvoie le contenu total de la table gene sous forme d'un tableau html
            La derniere colonne permet de supprimer des entrees (si les contraintes d'integrite le permettent)
 Args     : Le nom de la table
 Globals  : none

=cut
sub GetTableHtmlDelete
{
    my $self = shift;
    
    my ($table) = (@_);
    my $ra_objects = &O2DBI::O2DBI_WebUtils::ExecuteFetchall($table);
    my $html = "";
    my $f = 1;
    foreach my $o_obj (sort { $a->nom() cmp $b->nom() } @$ra_objects)
    {
        my $is_antibio = ($o_obj->antibio==1) ? '<strong>Y</strong>' : 'N';
        $html .= "<tr><td>".$o_obj->nom."</td><td>".$o_obj->description."</td><td>".$is_antibio."</td><td>"."<input type=\"checkbox\" name=\"fieldD${f}:${table}.id\" value=\"".$o_obj->id."\" />"."</td></tr>";
        $f++;
    }
    
    return $html;
}

1;

