# Copyright INRA/CNRS
# 
# Emmanuel.Courcelle@toulouse.inra.fr
# Sebastien.Carrere@toulouse.inra.fr
# 
# Ce logiciel est un programme informatique servant à [rappeler les
# caractéristiques techniques de votre logiciel]. 
# 
# Ce logiciel est régi par la licence [CeCILL|CeCILL-B|CeCILL-C] soumise au droit français et
# respectant les principes de diffusion des logiciels libres. Vous pouvez
# utiliser, modifier et/ou redistribuer ce programme sous les conditions
# de la licence [CeCILL|CeCILL-B|CeCILL-C] telle que diffusée par le CEA, le CNRS et l'INRIA 
# sur le site "http://www.cecill.info".
# 
# En contrepartie de l'accessibilité au code source et des droits de copie,
# de modification et de redistribution accordés par cette licence, il n'est
# offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
# seule une responsabilité restreinte pèse sur l'auteur du programme,  le
# titulaire des droits patrimoniaux et les concédants successifs.
# 
# A cet égard  l'attention de l'utilisateur est attirée sur les risques
# associés au chargement,  à l'utilisation,  à la modification et/ou au
# développement et à la reproduction du logiciel par l'utilisateur étant 
# donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
# manipuler et qui le réserve donc à des développeurs et des professionnels
# avertis possédant  des  connaissances  informatiques approfondies.  Les
# utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
# logiciel à leurs besoins dans des conditions permettant d'assurer la
# sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
# à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 
# 
# Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
# pris connaissance de la licence [CeCILL|CeCILL-B|CeCILL-C], et que vous en avez accepté les
# termes.

package DisplayCaracterep;

use strict;
use WebBuilder;

use O2DBI::DisplayTable;
use base qw(DisplayTable);

use O2DBI::DisplayField::CaracterepField;
 
=head2 Function _Init (the constructor)
 Title            : _Init
 Usage            : my $o_obj = New UpdateTable($o_cfg, $o_logger)
 Function         : threw the New function of LipmObject, builds the object
 Returns          : The object
 Args             : $o_cfg   = A ParamParser containing the configuration parameters
                    $o_logger= A Logger object (optional)
 Globals          : none

=cut
sub _Init
{
    my $self = shift;
    my ($o_cfg, $o_logger, $o_param, $rh_schema) = (@_);
    
    $self->SUPER::_Init(@_);
    
    # Declaring the main table name
    $self -> SetTableName('caracterep');
    
    # Creating the object useful for displaying fields (called by DisplayTable::GetTable, DisplayTable::GetRow)
    my $o_dspl = New DisplayField::CaracterepField(@_);
    $self->{__o_display_field} = $o_dspl;
    
    return $self;
}

sub SearchData
{
    my $self = shift;
    my @parameters = @_;
    return $self->_SearchData(@_);
}


1;

