package UpdateRevue;

use strict;
use WebBuilder;

use O2DBI::DisplayTable::DisplayRevue;

use O2DBI::UpdateTable;
use base qw(UpdateTable);

=head2 Function _Init (the constructor)
 Title            : _Init
 Usage            : my $o_obj = New UpdateTable($o_cfg, $o_logger)
 Function         : build the object, initializing a DisplaySouche object
 Returns          : The object
 Args             : $o_cfg   = A ParamParser containing the configuration parameters
                    $o_logger= A Logger object (optional)
 Globals          : none

=cut
sub _Init
{
    my $self = shift;
    my ($o_cfg, $o_logger, $o_param) = (@_);
    
    $self->SUPER::_Init(@_);
    $self -> SetTableName('revue');
    my $o_display_revue = New DisplayRevue(@_);
    $self -> { _o_display_table } = $o_display_revue;
    
    return $self;
}
   
1;

