package clism::DBMS;

use DBI;
use Cwd;
require Exporter;
@ISA    = qw{Exporter};
@EXPORT = qw{$clism_DBH newid};

use IO::File;

# Gestion de la connection a la base de donnees
if (defined $main::O_CFG and $main::O_CFG ne "")
{
    my $db_name = $main::O_CFG->Get('db_name');
    my $hostname = '';
    if ($main::O_CFG->IsDefined('db_host') && $main::O_CFG->Get('db_host') ne '')
    {
        $hostname = "host=" . $main::O_CFG->Get('db_host') . ";";
    }
    
    my $login="none";
    
    # Si le login est defini dans les parametres on l'utilise a la place de la val par defaut
    if ($main::O_PARAM->IsDefined('__wb_login') and $main::O_PARAM->Get('__wb_login') !~ /^clism_\s+$/)
    {
        $login = $main::O_PARAM->Get('__wb_login');
        
        # Si le mot de passe est defini dans les parametres on l'utilise aussi
        # On se connecte a la base de donnees et si OK on stocque le mot de passe dans le repertoire de session
        if ($main::O_PARAM->IsDefined('password') and $main::O_PARAM->Get('password') ne '')
        {
            my $password = $main::O_PARAM->Get('password');
            $clism_DBH = DBI->connect("dbi:Pg:dbname=$db_name;$hostname", $login, $password)  || &HTMLDie("can't connect to database: ". DBI::errstr);
            if (! DBI::err)
            {
                my $fh_pwd = new IO::File(">private/data");
                print $fh_pwd &Encrypt($password) if (defined $fh_pwd);
            }
        }
        else
        
        # Sinon on va le chercher dans le repertoire de session
        {
            my $fh_pwd = new IO::File("private/data");
            my $password = <$fh_pwd>;
            chomp($password);
            $password = &Decrypt($password);
            $clism_DBH = DBI->connect("dbi:Pg:dbname=$db_name;$hostname", $login, $password)  || &HTMLDie("can't connect to database: ". DBI::errstr);
        };
        
    }
    
    # Si pas de login dans les parametres on prend la valeur par defaut, si possible
    else
    {
        if ( $main::O_CFG->IsDefined('db_login_default') and $main::O_CFG->IsDefined('db_pass_default') )
        {
            $login = $main::O_CFG->Get('db_login_default');
            my $password = $main::O_CFG->Get('db_pass_default');
            $clism_DBH = DBI->connect("dbi:Pg:dbname=$db_name;$hostname", $login, $password)  || &HTMLDie("can't connect to database: ". DBI::errstr);
        }
    };

    
    # Le schema: si le user vaut db_login_defaut OU clism, le schema est db_schema_defaut
    # Si le user vaut clism_toto le schema est clism_toto
    # dans tous les cas on met le schema dans $O_CFG
    
    my $schema = "none";
    if ($login ne 'none')
    {
        if ($login eq $main::O_CFG->Get('db_login_default') or$main::O_CFG->Get('db_login_admin'))
        {
            $schema = $main::O_CFG->Get('db_schema_default');
        }
        else
        {
            $schema = $clism;
        };
        
        $clism_DBH->do("SET search_path TO " . $schema);
        #$main::O_PARAM->Set('schema_error', "$DBI::errstr");
        
        my $sth = $clism_DBH->prepare("SHOW search_path");
        $sth->execute;
        my ($real_path) = $sth->fetchrow_array;
        $sth->finish;
    }
    
    #$main::O_PARAM->Set('schema_used', $main::O_PARAM->Get('__wb_schema'));
    $main::O_CFG->Set('schema',$schema);
    $main::O_CFG->Set('login',$login);
}


sub Encrypt
{
    my ($data) = @_;
    
    my $pp = wd;
    eval "use Crypt::Simple passphrase => '$pp';";
    if ($@ ne "")
    { 
        # Something wrong in eval (may be Crypt::Simple is not installed ?)
        # Silently ignore the error, but the password will NOT be crypted
        return "0:$data";
    }
    else
    {
        return "1:" . encrypt($data);
    }
}

sub Decrypt
{
    my ($data) = @_;
    
    # 1:xxxxx ==> The xxxxx represents some crypted data !
    if ( $data =~ /^1:(.+)$/ )
    {
        my $crypted_data = $1;
        my $pp = wd;
        eval "use Crypt::Simple passphrase => '$pp';";
        if ($@ ne "")
        {
	    # pratique pour debugger, mais en bon parano je supprime en prod 
            # die "$@ MOT DE PASSE ILLISIBLE";
            die "MOT DE PASSE ILLISIBLE";
        }
        my ($decrypted_data) = decrypt($crypted_data);
        return $decrypted_data;
    };
    
    # 0:yyyy ==> The yyyyy represents some uncrypted data !
    if ( $data =~ /^0:(.+)$/ )
    {
        return $1;
    };
    
    # anything else ==> just return as-is
    return $data;
}

 
sub DBUsers
{
	 my @a_login_keys = $main::O_PARAM->GetKeys('db_login_\d+');
	 my %h_users = ();
	 foreach my $login_key (@a_login_keys)
	 {
	 	my ($number) = ($login_key =~ /db_login_(\d+)/);
		my $login = $main::O_PARAM->Get('db_login_' . $number);
		my $pass = $main::O_PARAM->Get('db_pass_' . $number);
		my $schema = $main::O_PARAM->Get('db_schema_' . $number);
		my %h_user = (password => $pass, schema => $schema);
		$h_users{$login} = \%h_user;
	 }

     
	return 	 \%h_users;

}

sub HTMLDie
{
	my $msg = shift();

	my $css = $main::O_CFG->Get('SERVERNAME') . '/' . $main::O_CFG->Get('HTTP_ROOT') . $main::O_CFG->Get('HTTP_CSS_DIR') . '/clism.css';
	
print STDOUT <<END;
Content-type:text/html

<html>
	<head>
		<title>Erreur Fatale</title>
		<link href="$css" rel="stylesheet" type="text/css">
	</head>
	<body>
		<h1>erreur</h1>
		<h4>$msg</h4>
	</body>
</html>
END

exit;
}

sub newid
{
    my ($table) = @_;
    $clism_DBH->{AutoCommit} = 0;
    #warn ("DEBUG 1");
    $clism_DBH->do(
        qq {
		LOCK clism_counters
	}
      )
      || return (-1);
    #warn ("DEBUG 2");

    my $sth = $clism_DBH->prepare(
        qq {
		SELECT val FROM clism_counters WHERE object='$table'
	}
    );
    $sth->execute;
    my ($curval) = $sth->fetchrow_array;
    $sth->finish;
    $curval++;
    $clism_DBH->do(
        qq {
	UPDATE clism_counters SET val=$curval WHERE object='$table'
	}
    );
    $clism_DBH->commit;
    $clism_DBH->{AutoCommit} = 1;
    return ($curval);
}

1;

