########################################################################
#
# This module was created automagically by O2DBI (1.24)
# Do not modify this file, changes will be lost!!!
#
# Additional methods can be defined in the file clism::antibios_add.pm.
#
########################################################################

package clism::antibios;

use clism::DBMS;

1;

########################################################################
#
# constructor and destructor methods for antibios
#
########################################################################

# create a new object and insert it into the database
sub create {
    my ($class, $caracterep_id, $souche_id) = @_;
    # fetch a fresh id
    my $id = newid('antibios');
        if ($id < 0) {
	return(-1);
    }
    # insert the primary key into the database
    $clism_DBH->do(qq {
            INSERT INTO antibios (id) VALUES ($id)
           });
    if ($clism_DBH->err) {
	return(-1);
    }
    # create the perl object
    my $antibios = { 'id' => $id,
		    '_buffer' => 1 };
    bless($antibios, $class);
    # fill in the remaining data
    $antibios->caracterep_id($caracterep_id);
    $antibios->souche_id($souche_id);
    if ($antibios->unbuffer < 0) {
	$antibios->delete;
	return(-1);
    } else {
	return($antibios);
    }
}

# create an object for already existing data
sub init_id {
    my ($class, $req_id) = @_;
    # fetch the data from the database
    my $sth = $clism_DBH->prepare(qq {
	SELECT souche_id, concentration, caracterep_id, commentaire, id FROM antibios
		WHERE id='$req_id'
	});
    $sth->execute;
    my ($souche_id, $concentration, $caracterep_id, $commentaire, $id) = $sth->fetchrow_array;
    $sth->finish;
    # if successful, return an appropriate object
    if (!defined($id)) {
	return(-1);
    } else {
	my $antibios = {
		'souche_id' => $souche_id, 
		'concentration' => $concentration, 
		'caracterep_id' => $caracterep_id, 
		'commentaire' => $commentaire, 
		'id' => $id
		};
        bless($antibios, $class);
        return($antibios);
    }
}

# get all objects from the database efficiently and return a hash reference
sub fetchallby_id {
    my ($class) = @_;
    local %antibios = ();
    my $sth = $clism_DBH->prepare(qq {
	SELECT souche_id, concentration, caracterep_id, commentaire, id FROM antibios
	});
    $sth->execute;
    while (($souche_id, $concentration, $caracterep_id, $commentaire, $id) = $sth->fetchrow_array) {
	my $antibios = {
		'souche_id' => $souche_id, 
		'concentration' => $concentration, 
		'caracterep_id' => $caracterep_id, 
		'commentaire' => $commentaire, 
		'id' => $id
		};
	bless($antibios, $class);
	$antibios{$id} = $antibios;
    }
    $sth->finish;
    return(\%antibios);
}

# create an object for already existing data
sub init_caracterep_id_souche_id {
    my ($class, $req_caracterep_id, $req_souche_id) = @_;
    # fetch the data from the database
    my $sth = $clism_DBH->prepare(qq {
	SELECT souche_id, concentration, caracterep_id, commentaire, id FROM antibios
		WHERE caracterep_id='$req_caracterep_id' AND souche_id='$req_souche_id'
	});
    $sth->execute;
    my ($souche_id, $concentration, $caracterep_id, $commentaire, $id) = $sth->fetchrow_array;
    $sth->finish;
    # if successful, return an appropriate object
    if (!defined($id)) {
	return(-1);
    } else {
	my $antibios = {
		'souche_id' => $souche_id, 
		'concentration' => $concentration, 
		'caracterep_id' => $caracterep_id, 
		'commentaire' => $commentaire, 
		'id' => $id
		};
        bless($antibios, $class);
        return($antibios);
    }
}

# get all objects from the database efficiently and return a hash reference
sub fetchallby_caracterep_id_souche_id {
    my ($class) = @_;
    local %antibios = ();
    my $sth = $clism_DBH->prepare(qq {
	SELECT souche_id, concentration, caracterep_id, commentaire, id FROM antibios
	});
    $sth->execute;
    while (($souche_id, $concentration, $caracterep_id, $commentaire, $id) = $sth->fetchrow_array) {
	my $antibios = {
		'souche_id' => $souche_id, 
		'concentration' => $concentration, 
		'caracterep_id' => $caracterep_id, 
		'commentaire' => $commentaire, 
		'id' => $id
		};
	bless($antibios, $class);
	my $key = join(',', $caracterep_id, $souche_id);
	$antibios{$key} = $antibios;
    }
    $sth->finish;
    return(\%antibios);
}

# get all those objects from the database efficiently that conform to the
# given WHERE clause and return an array reference
sub fetchbySQL {
    my ($class, $statement) = @_;
    local @antibios = ();
    my $sth = $clism_DBH->prepare(qq {
	SELECT souche_id, concentration, caracterep_id, commentaire, id FROM antibios WHERE $statement
	});
    $sth->execute;
    while (($souche_id, $concentration, $caracterep_id, $commentaire, $id) = $sth->fetchrow_array) {
	my $antibios = {
		'souche_id' => $souche_id, 
		'concentration' => $concentration, 
		'caracterep_id' => $caracterep_id, 
		'commentaire' => $commentaire, 
		'id' => $id
		};
	bless($antibios, $class);
	push(@antibios, $antibios);
    }
    $sth->finish;
    return(\@antibios);
}

# get all objects from the database efficiently and return an array reference
sub fetchall {
    my ($class) = @_;
    local @antibios = ();
    my $sth = $clism_DBH->prepare(qq {
	SELECT souche_id, concentration, caracterep_id, commentaire, id FROM antibios
	});
    $sth->execute;
    while (($souche_id, $concentration, $caracterep_id, $commentaire, $id) = $sth->fetchrow_array) {
	my $antibios = {
		'souche_id' => $souche_id, 
		'concentration' => $concentration, 
		'caracterep_id' => $caracterep_id, 
		'commentaire' => $commentaire, 
		'id' => $id
		};
	bless($antibios, $class);
	push(@antibios, $antibios);
    }
    $sth->finish;
    return(\@antibios);
}

# delete an object completely from the database
sub delete {
    my ($self) = @_;
    my $id = $self->id;
    $clism_DBH->do(qq {
	DELETE FROM antibios WHERE id=$id
	}) || return(-1);
    undef($self);
}

########################################################################
#
# methods to access the member variables
#
########################################################################

# get or set the member variable 'souche_id'
sub souche_id {
    my ($self, $souche_id) = @_;
    return($self->getset('souche_id', $souche_id));
}

# get or set the member variable 'concentration'
sub concentration {
    my ($self, $concentration) = @_;
    return($self->getset('concentration', $concentration));
}

# get or set the member variable 'caracterep_id'
sub caracterep_id {
    my ($self, $caracterep_id) = @_;
    return($self->getset('caracterep_id', $caracterep_id));
}

# get or set the member variable 'commentaire'
sub commentaire {
    my ($self, $commentaire) = @_;
    return($self->getset('commentaire', $commentaire));
}

# get the member variable 'id'
sub id {
    my ($self) = @_;
    return($self->{'id'});
}

# set several member variables at the same time
sub mset {
    my ($self, $hashref) = @_;
    my $curbuffer = $self->buffered;
    $self->buffer;
    foreach $key (keys(%$hashref)) {
	# prevent really stupid tricks
	if ($key eq 'id') {
	    return(-1);
	}
	my $val = $hashref->{$key};
	&$key($self, $val);
    }
    if (!$curbuffer) {
	$self->unbuffer;
    }
}

########################################################################
#
# load additional methods from self made module
#
########################################################################

#require clism::antibios_add;

########################################################################
#
# private functions used inside this module
#
########################################################################

# test if the data is buffered or passed to the DBMS immediately
sub buffered {
    my ($self) = @_;
    return($self->{'_buffer'});
}

# make the data buffered, i.e. don't write to the database
sub buffer {
    my ($self) = @_;
    $self->{'_buffer'} = 1;
}

# write the current contents to the database and declare the object unbuffered
sub unbuffer {
    my ($self) = @_;
    if ($self->buffered) {
	my @sql = ();
	foreach $key (qw{souche_id concentration caracterep_id commentaire id}) {
	    push(@sql, "$key=".$clism_DBH->quote($self->{$key}));
	}
	my $id = $self->id;
	my $sql = "UPDATE antibios SET ".join(', ', @sql)." WHERE id=$id";
	$clism_DBH->do($sql) || return(-1);
    }
    $self->{'_buffer'} = 0;
}

# get or set one of the member variables
sub getset {
    my ($self, $var, $val) = @_;
    my $id = $self->id;
    if (defined($val)) {
	if (!$self->buffered) {
	    my $qval = $clism_DBH->quote($val);
	    $clism_DBH->do(qq {
		UPDATE antibios SET $var=$qval WHERE id=$id
		}) || return(-1);
	}
	$self->{$var} = $val;
    }
    return($self->{$var});
}

