########################################################################
#
# This module was created automagically by O2DBI (1.24)
# Do not modify this file, changes will be lost!!!
#
# Additional methods can be defined in the file clism::biblio_add.pm.
#
########################################################################

package clism::biblio;

use clism::DBMS;

1;

########################################################################
#
# constructor and destructor methods for biblio
#
########################################################################

# create a new object and insert it into the database
sub create {
    my ($class, ) = @_;
    # fetch a fresh id
    my $id = newid('biblio');
        if ($id < 0) {
	return(-1);
    }
    # insert the primary key into the database
    $clism_DBH->do(qq {
            INSERT INTO biblio (id) VALUES ($id)
           });
    if ($clism_DBH->err) {
	return(-1);
    }
    # create the perl object
    my $biblio = { 'id' => $id,
		    '_buffer' => 1 };
    bless($biblio, $class);
    # fill in the remaining data
    if ($biblio->unbuffer < 0) {
	$biblio->delete;
	return(-1);
    } else {
	return($biblio);
    }
}

# create an object for already existing data
sub init_id {
    my ($class, $req_id) = @_;
    # fetch the data from the database
    my $sth = $clism_DBH->prepare(qq {
	SELECT revue_id, numero, volume, titre, annee, motscles, editeur_id, url, auteurs, id, livre, pages FROM biblio
		WHERE id='$req_id'
	});
    $sth->execute;
    my ($revue_id, $numero, $volume, $titre, $annee, $motscles, $editeur_id, $url, $auteurs, $id, $livre, $pages) = $sth->fetchrow_array;
    $sth->finish;
    # if successful, return an appropriate object
    if (!defined($id)) {
	return(-1);
    } else {
	my $biblio = {
		'revue_id' => $revue_id, 
		'numero' => $numero, 
		'volume' => $volume, 
		'titre' => $titre, 
		'annee' => $annee, 
		'motscles' => $motscles, 
		'editeur_id' => $editeur_id, 
		'url' => $url, 
		'auteurs' => $auteurs, 
		'id' => $id, 
		'livre' => $livre, 
		'pages' => $pages
		};
        bless($biblio, $class);
        return($biblio);
    }
}

# get all objects from the database efficiently and return a hash reference
sub fetchallby_id {
    my ($class) = @_;
    local %biblio = ();
    my $sth = $clism_DBH->prepare(qq {
	SELECT revue_id, numero, volume, titre, annee, motscles, editeur_id, url, auteurs, id, livre, pages FROM biblio
	});
    $sth->execute;
    while (($revue_id, $numero, $volume, $titre, $annee, $motscles, $editeur_id, $url, $auteurs, $id, $livre, $pages) = $sth->fetchrow_array) {
	my $biblio = {
		'revue_id' => $revue_id, 
		'numero' => $numero, 
		'volume' => $volume, 
		'titre' => $titre, 
		'annee' => $annee, 
		'motscles' => $motscles, 
		'editeur_id' => $editeur_id, 
		'url' => $url, 
		'auteurs' => $auteurs, 
		'id' => $id, 
		'livre' => $livre, 
		'pages' => $pages
		};
	bless($biblio, $class);
	$biblio{$id} = $biblio;
    }
    $sth->finish;
    return(\%biblio);
}

# get all those objects from the database efficiently that conform to the
# given WHERE clause and return an array reference
sub fetchbySQL {
    my ($class, $statement) = @_;
    local @biblio = ();
    my $sth = $clism_DBH->prepare(qq {
	SELECT revue_id, numero, volume, titre, annee, motscles, editeur_id, url, auteurs, id, livre, pages FROM biblio WHERE $statement
	});
    $sth->execute;
    while (($revue_id, $numero, $volume, $titre, $annee, $motscles, $editeur_id, $url, $auteurs, $id, $livre, $pages) = $sth->fetchrow_array) {
	my $biblio = {
		'revue_id' => $revue_id, 
		'numero' => $numero, 
		'volume' => $volume, 
		'titre' => $titre, 
		'annee' => $annee, 
		'motscles' => $motscles, 
		'editeur_id' => $editeur_id, 
		'url' => $url, 
		'auteurs' => $auteurs, 
		'id' => $id, 
		'livre' => $livre, 
		'pages' => $pages
		};
	bless($biblio, $class);
	push(@biblio, $biblio);
    }
    $sth->finish;
    return(\@biblio);
}

# get all objects from the database efficiently and return an array reference
sub fetchall {
    my ($class) = @_;
    local @biblio = ();
    my $sth = $clism_DBH->prepare(qq {
	SELECT revue_id, numero, volume, titre, annee, motscles, editeur_id, url, auteurs, id, livre, pages FROM biblio
	});
    $sth->execute;
    while (($revue_id, $numero, $volume, $titre, $annee, $motscles, $editeur_id, $url, $auteurs, $id, $livre, $pages) = $sth->fetchrow_array) {
	my $biblio = {
		'revue_id' => $revue_id, 
		'numero' => $numero, 
		'volume' => $volume, 
		'titre' => $titre, 
		'annee' => $annee, 
		'motscles' => $motscles, 
		'editeur_id' => $editeur_id, 
		'url' => $url, 
		'auteurs' => $auteurs, 
		'id' => $id, 
		'livre' => $livre, 
		'pages' => $pages
		};
	bless($biblio, $class);
	push(@biblio, $biblio);
    }
    $sth->finish;
    return(\@biblio);
}

# delete an object completely from the database
sub delete {
    my ($self) = @_;
    my $id = $self->id;
    $clism_DBH->do(qq {
	DELETE FROM biblio WHERE id=$id
	}) || return(-1);
    undef($self);
}

########################################################################
#
# methods to access the member variables
#
########################################################################

# get or set the member variable 'revue_id'
sub revue_id {
    my ($self, $revue_id) = @_;
    return($self->getset('revue_id', $revue_id));
}

# get or set the member variable 'numero'
sub numero {
    my ($self, $numero) = @_;
    return($self->getset('numero', $numero));
}

# get or set the member variable 'volume'
sub volume {
    my ($self, $volume) = @_;
    return($self->getset('volume', $volume));
}

# get or set the member variable 'titre'
sub titre {
    my ($self, $titre) = @_;
    return($self->getset('titre', $titre));
}

# get or set the member variable 'annee'
sub annee {
    my ($self, $annee) = @_;
    return($self->getset('annee', $annee));
}

# get or set the member variable 'motscles'
sub motscles {
    my ($self, $motscles) = @_;
    return($self->getset('motscles', $motscles));
}

# get or set the member variable 'editeur_id'
sub editeur_id {
    my ($self, $editeur_id) = @_;
    return($self->getset('editeur_id', $editeur_id));
}

# get or set the member variable 'url'
sub url {
    my ($self, $url) = @_;
    return($self->getset('url', $url));
}

# get or set the member variable 'auteurs'
sub auteurs {
    my ($self, $auteurs) = @_;
    return($self->getset('auteurs', $auteurs));
}

# get the member variable 'id'
sub id {
    my ($self) = @_;
    return($self->{'id'});
}

# get or set the member variable 'livre'
sub livre {
    my ($self, $livre) = @_;
    return($self->getset('livre', $livre));
}

# get or set the member variable 'pages'
sub pages {
    my ($self, $pages) = @_;
    return($self->getset('pages', $pages));
}

# set several member variables at the same time
sub mset {
    my ($self, $hashref) = @_;
    my $curbuffer = $self->buffered;
    $self->buffer;
    foreach $key (keys(%$hashref)) {
	# prevent really stupid tricks
	if ($key eq 'id') {
	    return(-1);
	}
	my $val = $hashref->{$key};
	&$key($self, $val);
    }
    if (!$curbuffer) {
	$self->unbuffer;
    }
}

########################################################################
#
# load additional methods from self made module
#
########################################################################

#require clism::biblio_add;

########################################################################
#
# private functions used inside this module
#
########################################################################

# test if the data is buffered or passed to the DBMS immediately
sub buffered {
    my ($self) = @_;
    return($self->{'_buffer'});
}

# make the data buffered, i.e. don't write to the database
sub buffer {
    my ($self) = @_;
    $self->{'_buffer'} = 1;
}

# write the current contents to the database and declare the object unbuffered
sub unbuffer {
    my ($self) = @_;
    if ($self->buffered) {
	my @sql = ();
	foreach $key (qw{revue_id numero volume titre annee motscles editeur_id url auteurs id livre pages}) {
	    push(@sql, "$key=".$clism_DBH->quote($self->{$key}));
	}
	my $id = $self->id;
	my $sql = "UPDATE biblio SET ".join(', ', @sql)." WHERE id=$id";
	$clism_DBH->do($sql) || return(-1);
    }
    $self->{'_buffer'} = 0;
}

# get or set one of the member variables
sub getset {
    my ($self, $var, $val) = @_;
    my $id = $self->id;
    if (defined($val)) {
	if (!$self->buffered) {
	    my $qval = $clism_DBH->quote($val);
	    $clism_DBH->do(qq {
		UPDATE biblio SET $var=$qval WHERE id=$id
		}) || return(-1);
	}
	$self->{$var} = $val;
    }
    return($self->{$var});
}

