########################################################################
#
# This module was created automagically by O2DBI (1.24)
# Do not modify this file, changes will be lost!!!
#
# Additional methods can be defined in the file clism::gene_plasmide_add.pm.
#
########################################################################

package clism::gene_plasmide;

use clism::DBMS;

1;

########################################################################
#
# constructor and destructor methods for gene_plasmide
#
########################################################################

# create a new object and insert it into the database
sub create {
    my ($class, $gene_id, $plasmide_id) = @_;
    # fetch a fresh id
    my $id = newid('gene_plasmide');
        if ($id < 0) {
	return(-1);
    }
    # insert the primary key into the database
    $clism_DBH->do(qq {
            INSERT INTO gene_plasmide (id) VALUES ($id)
           });
    if ($clism_DBH->err) {
	return(-1);
    }
    # create the perl object
    my $gene_plasmide = { 'id' => $id,
		    '_buffer' => 1 };
    bless($gene_plasmide, $class);
    # fill in the remaining data
    $gene_plasmide->gene_id($gene_id);
    $gene_plasmide->plasmide_id($plasmide_id);
    if ($gene_plasmide->unbuffer < 0) {
	$gene_plasmide->delete;
	return(-1);
    } else {
	return($gene_plasmide);
    }
}

# create an object for already existing data
sub init_id {
    my ($class, $req_id) = @_;
    # fetch the data from the database
    my $sth = $clism_DBH->prepare(qq {
	SELECT gene_id, plasmide_id, id FROM gene_plasmide
		WHERE id='$req_id'
	});
    $sth->execute;
    my ($gene_id, $plasmide_id, $id) = $sth->fetchrow_array;
    $sth->finish;
    # if successful, return an appropriate object
    if (!defined($id)) {
	return(-1);
    } else {
	my $gene_plasmide = {
		'gene_id' => $gene_id, 
		'plasmide_id' => $plasmide_id, 
		'id' => $id
		};
        bless($gene_plasmide, $class);
        return($gene_plasmide);
    }
}

# get all objects from the database efficiently and return a hash reference
sub fetchallby_id {
    my ($class) = @_;
    local %gene_plasmide = ();
    my $sth = $clism_DBH->prepare(qq {
	SELECT gene_id, plasmide_id, id FROM gene_plasmide
	});
    $sth->execute;
    while (($gene_id, $plasmide_id, $id) = $sth->fetchrow_array) {
	my $gene_plasmide = {
		'gene_id' => $gene_id, 
		'plasmide_id' => $plasmide_id, 
		'id' => $id
		};
	bless($gene_plasmide, $class);
	$gene_plasmide{$id} = $gene_plasmide;
    }
    $sth->finish;
    return(\%gene_plasmide);
}

# create an object for already existing data
sub init_gene_id_plasmide_id {
    my ($class, $req_gene_id, $req_plasmide_id) = @_;
    # fetch the data from the database
    my $sth = $clism_DBH->prepare(qq {
	SELECT gene_id, plasmide_id, id FROM gene_plasmide
		WHERE gene_id='$req_gene_id' AND plasmide_id='$req_plasmide_id'
	});
    $sth->execute;
    my ($gene_id, $plasmide_id, $id) = $sth->fetchrow_array;
    $sth->finish;
    # if successful, return an appropriate object
    if (!defined($id)) {
	return(-1);
    } else {
	my $gene_plasmide = {
		'gene_id' => $gene_id, 
		'plasmide_id' => $plasmide_id, 
		'id' => $id
		};
        bless($gene_plasmide, $class);
        return($gene_plasmide);
    }
}

# get all objects from the database efficiently and return a hash reference
sub fetchallby_gene_id_plasmide_id {
    my ($class) = @_;
    local %gene_plasmide = ();
    my $sth = $clism_DBH->prepare(qq {
	SELECT gene_id, plasmide_id, id FROM gene_plasmide
	});
    $sth->execute;
    while (($gene_id, $plasmide_id, $id) = $sth->fetchrow_array) {
	my $gene_plasmide = {
		'gene_id' => $gene_id, 
		'plasmide_id' => $plasmide_id, 
		'id' => $id
		};
	bless($gene_plasmide, $class);
	my $key = join(',', $gene_id, $plasmide_id);
	$gene_plasmide{$key} = $gene_plasmide;
    }
    $sth->finish;
    return(\%gene_plasmide);
}

# get all those objects from the database efficiently that conform to the
# given WHERE clause and return an array reference
sub fetchbySQL {
    my ($class, $statement) = @_;
    local @gene_plasmide = ();
    my $sth = $clism_DBH->prepare(qq {
	SELECT gene_id, plasmide_id, id FROM gene_plasmide WHERE $statement
	});
    $sth->execute;
    while (($gene_id, $plasmide_id, $id) = $sth->fetchrow_array) {
	my $gene_plasmide = {
		'gene_id' => $gene_id, 
		'plasmide_id' => $plasmide_id, 
		'id' => $id
		};
	bless($gene_plasmide, $class);
	push(@gene_plasmide, $gene_plasmide);
    }
    $sth->finish;
    return(\@gene_plasmide);
}

# get all objects from the database efficiently and return an array reference
sub fetchall {
    my ($class) = @_;
    local @gene_plasmide = ();
    my $sth = $clism_DBH->prepare(qq {
	SELECT gene_id, plasmide_id, id FROM gene_plasmide
	});
    $sth->execute;
    while (($gene_id, $plasmide_id, $id) = $sth->fetchrow_array) {
	my $gene_plasmide = {
		'gene_id' => $gene_id, 
		'plasmide_id' => $plasmide_id, 
		'id' => $id
		};
	bless($gene_plasmide, $class);
	push(@gene_plasmide, $gene_plasmide);
    }
    $sth->finish;
    return(\@gene_plasmide);
}

# delete an object completely from the database
sub delete {
    my ($self) = @_;
    my $id = $self->id;
    $clism_DBH->do(qq {
	DELETE FROM gene_plasmide WHERE id=$id
	}) || return(-1);
    undef($self);
}

########################################################################
#
# methods to access the member variables
#
########################################################################

# get or set the member variable 'gene_id'
sub gene_id {
    my ($self, $gene_id) = @_;
    return($self->getset('gene_id', $gene_id));
}

# get or set the member variable 'plasmide_id'
sub plasmide_id {
    my ($self, $plasmide_id) = @_;
    return($self->getset('plasmide_id', $plasmide_id));
}

# get the member variable 'id'
sub id {
    my ($self) = @_;
    return($self->{'id'});
}

# set several member variables at the same time
sub mset {
    my ($self, $hashref) = @_;
    my $curbuffer = $self->buffered;
    $self->buffer;
    foreach $key (keys(%$hashref)) {
	# prevent really stupid tricks
	if ($key eq 'id') {
	    return(-1);
	}
	my $val = $hashref->{$key};
	&$key($self, $val);
    }
    if (!$curbuffer) {
	$self->unbuffer;
    }
}

########################################################################
#
# load additional methods from self made module
#
########################################################################

#require clism::gene_plasmide_add;

########################################################################
#
# private functions used inside this module
#
########################################################################

# test if the data is buffered or passed to the DBMS immediately
sub buffered {
    my ($self) = @_;
    return($self->{'_buffer'});
}

# make the data buffered, i.e. don't write to the database
sub buffer {
    my ($self) = @_;
    $self->{'_buffer'} = 1;
}

# write the current contents to the database and declare the object unbuffered
sub unbuffer {
    my ($self) = @_;
    if ($self->buffered) {
	my @sql = ();
	foreach $key (qw{gene_id plasmide_id id}) {
	    push(@sql, "$key=".$clism_DBH->quote($self->{$key}));
	}
	my $id = $self->id;
	my $sql = "UPDATE gene_plasmide SET ".join(', ', @sql)." WHERE id=$id";
	$clism_DBH->do($sql) || return(-1);
    }
    $self->{'_buffer'} = 0;
}

# get or set one of the member variables
sub getset {
    my ($self, $var, $val) = @_;
    my $id = $self->id;
    if (defined($val)) {
	if (!$self->buffered) {
	    my $qval = $clism_DBH->quote($val);
	    $clism_DBH->do(qq {
		UPDATE gene_plasmide SET $var=$qval WHERE id=$id
		}) || return(-1);
	}
	$self->{$var} = $val;
    }
    return($self->{$var});
}

