########################################################################
#
# This module was created automagically by O2DBI (1.24)
# Do not modify this file, changes will be lost!!!
#
# Additional methods can be defined in the file clism::phenotypeconfere_add.pm.
#
########################################################################

package clism::phenotypeconfere;

use clism::DBMS;

1;

########################################################################
#
# constructor and destructor methods for phenotypeconfere
#
########################################################################

# create a new object and insert it into the database
sub create {
    my ($class, $caracterep_id, $plasmide_id) = @_;
    # fetch a fresh id
    my $id = newid('phenotypeconfere');
        if ($id < 0) {
	return(-1);
    }
    # insert the primary key into the database
    $clism_DBH->do(qq {
            INSERT INTO phenotypeconfere (id) VALUES ($id)
           });
    if ($clism_DBH->err) {
	return(-1);
    }
    # create the perl object
    my $phenotypeconfere = { 'id' => $id,
		    '_buffer' => 1 };
    bless($phenotypeconfere, $class);
    # fill in the remaining data
    $phenotypeconfere->caracterep_id($caracterep_id);
    $phenotypeconfere->plasmide_id($plasmide_id);
    if ($phenotypeconfere->unbuffer < 0) {
	$phenotypeconfere->delete;
	return(-1);
    } else {
	return($phenotypeconfere);
    }
}

# create an object for already existing data
sub init_id {
    my ($class, $req_id) = @_;
    # fetch the data from the database
    my $sth = $clism_DBH->prepare(qq {
	SELECT concentration, plasmide_id, caracterep_id, commentaire, id FROM phenotypeconfere
		WHERE id='$req_id'
	});
    $sth->execute;
    my ($concentration, $plasmide_id, $caracterep_id, $commentaire, $id) = $sth->fetchrow_array;
    $sth->finish;
    # if successful, return an appropriate object
    if (!defined($id)) {
	return(-1);
    } else {
	my $phenotypeconfere = {
		'concentration' => $concentration, 
		'plasmide_id' => $plasmide_id, 
		'caracterep_id' => $caracterep_id, 
		'commentaire' => $commentaire, 
		'id' => $id
		};
        bless($phenotypeconfere, $class);
        return($phenotypeconfere);
    }
}

# get all objects from the database efficiently and return a hash reference
sub fetchallby_id {
    my ($class) = @_;
    local %phenotypeconfere = ();
    my $sth = $clism_DBH->prepare(qq {
	SELECT concentration, plasmide_id, caracterep_id, commentaire, id FROM phenotypeconfere
	});
    $sth->execute;
    while (($concentration, $plasmide_id, $caracterep_id, $commentaire, $id) = $sth->fetchrow_array) {
	my $phenotypeconfere = {
		'concentration' => $concentration, 
		'plasmide_id' => $plasmide_id, 
		'caracterep_id' => $caracterep_id, 
		'commentaire' => $commentaire, 
		'id' => $id
		};
	bless($phenotypeconfere, $class);
	$phenotypeconfere{$id} = $phenotypeconfere;
    }
    $sth->finish;
    return(\%phenotypeconfere);
}

# create an object for already existing data
sub init_caracterep_id_plasmide_id {
    my ($class, $req_caracterep_id, $req_plasmide_id) = @_;
    # fetch the data from the database
    my $sth = $clism_DBH->prepare(qq {
	SELECT concentration, plasmide_id, caracterep_id, commentaire, id FROM phenotypeconfere
		WHERE caracterep_id='$req_caracterep_id' AND plasmide_id='$req_plasmide_id'
	});
    $sth->execute;
    my ($concentration, $plasmide_id, $caracterep_id, $commentaire, $id) = $sth->fetchrow_array;
    $sth->finish;
    # if successful, return an appropriate object
    if (!defined($id)) {
	return(-1);
    } else {
	my $phenotypeconfere = {
		'concentration' => $concentration, 
		'plasmide_id' => $plasmide_id, 
		'caracterep_id' => $caracterep_id, 
		'commentaire' => $commentaire, 
		'id' => $id
		};
        bless($phenotypeconfere, $class);
        return($phenotypeconfere);
    }
}

# get all objects from the database efficiently and return a hash reference
sub fetchallby_caracterep_id_plasmide_id {
    my ($class) = @_;
    local %phenotypeconfere = ();
    my $sth = $clism_DBH->prepare(qq {
	SELECT concentration, plasmide_id, caracterep_id, commentaire, id FROM phenotypeconfere
	});
    $sth->execute;
    while (($concentration, $plasmide_id, $caracterep_id, $commentaire, $id) = $sth->fetchrow_array) {
	my $phenotypeconfere = {
		'concentration' => $concentration, 
		'plasmide_id' => $plasmide_id, 
		'caracterep_id' => $caracterep_id, 
		'commentaire' => $commentaire, 
		'id' => $id
		};
	bless($phenotypeconfere, $class);
	my $key = join(',', $caracterep_id, $plasmide_id);
	$phenotypeconfere{$key} = $phenotypeconfere;
    }
    $sth->finish;
    return(\%phenotypeconfere);
}

# get all those objects from the database efficiently that conform to the
# given WHERE clause and return an array reference
sub fetchbySQL {
    my ($class, $statement) = @_;
    local @phenotypeconfere = ();
    my $sth = $clism_DBH->prepare(qq {
	SELECT concentration, plasmide_id, caracterep_id, commentaire, id FROM phenotypeconfere WHERE $statement
	});
    $sth->execute;
    while (($concentration, $plasmide_id, $caracterep_id, $commentaire, $id) = $sth->fetchrow_array) {
	my $phenotypeconfere = {
		'concentration' => $concentration, 
		'plasmide_id' => $plasmide_id, 
		'caracterep_id' => $caracterep_id, 
		'commentaire' => $commentaire, 
		'id' => $id
		};
	bless($phenotypeconfere, $class);
	push(@phenotypeconfere, $phenotypeconfere);
    }
    $sth->finish;
    return(\@phenotypeconfere);
}

# get all objects from the database efficiently and return an array reference
sub fetchall {
    my ($class) = @_;
    local @phenotypeconfere = ();
    my $sth = $clism_DBH->prepare(qq {
	SELECT concentration, plasmide_id, caracterep_id, commentaire, id FROM phenotypeconfere
	});
    $sth->execute;
    while (($concentration, $plasmide_id, $caracterep_id, $commentaire, $id) = $sth->fetchrow_array) {
	my $phenotypeconfere = {
		'concentration' => $concentration, 
		'plasmide_id' => $plasmide_id, 
		'caracterep_id' => $caracterep_id, 
		'commentaire' => $commentaire, 
		'id' => $id
		};
	bless($phenotypeconfere, $class);
	push(@phenotypeconfere, $phenotypeconfere);
    }
    $sth->finish;
    return(\@phenotypeconfere);
}

# delete an object completely from the database
sub delete {
    my ($self) = @_;
    my $id = $self->id;
    $clism_DBH->do(qq {
	DELETE FROM phenotypeconfere WHERE id=$id
	}) || return(-1);
    undef($self);
}

########################################################################
#
# methods to access the member variables
#
########################################################################

# get or set the member variable 'concentration'
sub concentration {
    my ($self, $concentration) = @_;
    return($self->getset('concentration', $concentration));
}

# get or set the member variable 'plasmide_id'
sub plasmide_id {
    my ($self, $plasmide_id) = @_;
    return($self->getset('plasmide_id', $plasmide_id));
}

# get or set the member variable 'caracterep_id'
sub caracterep_id {
    my ($self, $caracterep_id) = @_;
    return($self->getset('caracterep_id', $caracterep_id));
}

# get or set the member variable 'commentaire'
sub commentaire {
    my ($self, $commentaire) = @_;
    return($self->getset('commentaire', $commentaire));
}

# get the member variable 'id'
sub id {
    my ($self) = @_;
    return($self->{'id'});
}

# set several member variables at the same time
sub mset {
    my ($self, $hashref) = @_;
    my $curbuffer = $self->buffered;
    $self->buffer;
    foreach $key (keys(%$hashref)) {
	# prevent really stupid tricks
	if ($key eq 'id') {
	    return(-1);
	}
	my $val = $hashref->{$key};
	&$key($self, $val);
    }
    if (!$curbuffer) {
	$self->unbuffer;
    }
}

########################################################################
#
# load additional methods from self made module
#
########################################################################

#require clism::phenotypeconfere_add;

########################################################################
#
# private functions used inside this module
#
########################################################################

# test if the data is buffered or passed to the DBMS immediately
sub buffered {
    my ($self) = @_;
    return($self->{'_buffer'});
}

# make the data buffered, i.e. don't write to the database
sub buffer {
    my ($self) = @_;
    $self->{'_buffer'} = 1;
}

# write the current contents to the database and declare the object unbuffered
sub unbuffer {
    my ($self) = @_;
    if ($self->buffered) {
	my @sql = ();
	foreach $key (qw{concentration plasmide_id caracterep_id commentaire id}) {
	    push(@sql, "$key=".$clism_DBH->quote($self->{$key}));
	}
	my $id = $self->id;
	my $sql = "UPDATE phenotypeconfere SET ".join(', ', @sql)." WHERE id=$id";
	$clism_DBH->do($sql) || return(-1);
    }
    $self->{'_buffer'} = 0;
}

# get or set one of the member variables
sub getset {
    my ($self, $var, $val) = @_;
    my $id = $self->id;
    if (defined($val)) {
	if (!$self->buffered) {
	    my $qval = $clism_DBH->quote($val);
	    $clism_DBH->do(qq {
		UPDATE phenotypeconfere SET $var=$qval WHERE id=$id
		}) || return(-1);
	}
	$self->{$var} = $val;
    }
    return($self->{$var});
}

