########################################################################
#
# This module was created automagically by O2DBI (1.24)
# Do not modify this file, changes will be lost!!!
#
# Additional methods can be defined in the file clism::souche_add.pm.
#
########################################################################

package clism::souche;

use clism::DBMS;

1;

########################################################################
#
# constructor and destructor methods for souche
#
########################################################################

# create a new object and insert it into the database
sub create {
    my ($class, $code, $espece_id) = @_;
    # fetch a fresh id
    my $id = newid('souche');
        if ($id < 0) {
	return(-1);
    }
    # insert the primary key into the database
    $clism_DBH->do(qq {
            INSERT INTO souche (id) VALUES ($id)
           });
    if ($clism_DBH->err) {
	return(-1);
    }
    # create the perl object
    my $souche = { 'id' => $id,
		    '_buffer' => 1 };
    bless($souche, $class);
    # fill in the remaining data
    $souche->code($code);
    $souche->espece_id($espece_id);
    if ($souche->unbuffer < 0) {
	$souche->delete;
	return(-1);
    } else {
	return($souche);
    }
}

# create an object for already existing data
sub init_id {
    my ($class, $req_id) = @_;
    # fetch the data from the database
    my $sth = $clism_DBH->prepare(qq {
	SELECT proprietes, numero, gmi80, date, espece_id, ligneboite, construitpar, construction, rdate, numeroboite, id, code, parents, colonneboite FROM souche
		WHERE id='$req_id'
	});
    $sth->execute;
    my ($proprietes, $numero, $gmi80, $date, $espece_id, $ligneboite, $construitpar, $construction, $rdate, $numeroboite, $id, $code, $parents, $colonneboite) = $sth->fetchrow_array;
    $sth->finish;
    # if successful, return an appropriate object
    if (!defined($id)) {
	return(-1);
    } else {
	my $souche = {
		'proprietes' => $proprietes, 
		'numero' => $numero, 
		'gmi80' => $gmi80, 
		'date' => $date, 
		'espece_id' => $espece_id, 
		'ligneboite' => $ligneboite, 
		'construitpar' => $construitpar, 
		'construction' => $construction, 
		'rdate' => $rdate, 
		'numeroboite' => $numeroboite, 
		'id' => $id, 
		'code' => $code, 
		'parents' => $parents, 
		'colonneboite' => $colonneboite
		};
        bless($souche, $class);
        return($souche);
    }
}

# get all objects from the database efficiently and return a hash reference
sub fetchallby_id {
    my ($class) = @_;
    local %souche = ();
    my $sth = $clism_DBH->prepare(qq {
	SELECT proprietes, numero, gmi80, date, espece_id, ligneboite, construitpar, construction, rdate, numeroboite, id, code, parents, colonneboite FROM souche
	});
    $sth->execute;
    while (($proprietes, $numero, $gmi80, $date, $espece_id, $ligneboite, $construitpar, $construction, $rdate, $numeroboite, $id, $code, $parents, $colonneboite) = $sth->fetchrow_array) {
	my $souche = {
		'proprietes' => $proprietes, 
		'numero' => $numero, 
		'gmi80' => $gmi80, 
		'date' => $date, 
		'espece_id' => $espece_id, 
		'ligneboite' => $ligneboite, 
		'construitpar' => $construitpar, 
		'construction' => $construction, 
		'rdate' => $rdate, 
		'numeroboite' => $numeroboite, 
		'id' => $id, 
		'code' => $code, 
		'parents' => $parents, 
		'colonneboite' => $colonneboite
		};
	bless($souche, $class);
	$souche{$id} = $souche;
    }
    $sth->finish;
    return(\%souche);
}

# create an object for already existing data
sub init_code {
    my ($class, $req_code) = @_;
    # fetch the data from the database
    my $sth = $clism_DBH->prepare(qq {
	SELECT proprietes, numero, gmi80, date, espece_id, ligneboite, construitpar, construction, rdate, numeroboite, id, code, parents, colonneboite FROM souche
		WHERE code='$req_code'
	});
    $sth->execute;
    my ($proprietes, $numero, $gmi80, $date, $espece_id, $ligneboite, $construitpar, $construction, $rdate, $numeroboite, $id, $code, $parents, $colonneboite) = $sth->fetchrow_array;
    $sth->finish;
    # if successful, return an appropriate object
    if (!defined($id)) {
	return(-1);
    } else {
	my $souche = {
		'proprietes' => $proprietes, 
		'numero' => $numero, 
		'gmi80' => $gmi80, 
		'date' => $date, 
		'espece_id' => $espece_id, 
		'ligneboite' => $ligneboite, 
		'construitpar' => $construitpar, 
		'construction' => $construction, 
		'rdate' => $rdate, 
		'numeroboite' => $numeroboite, 
		'id' => $id, 
		'code' => $code, 
		'parents' => $parents, 
		'colonneboite' => $colonneboite
		};
        bless($souche, $class);
        return($souche);
    }
}

# get all objects from the database efficiently and return a hash reference
sub fetchallby_code {
    my ($class) = @_;
    local %souche = ();
    my $sth = $clism_DBH->prepare(qq {
	SELECT proprietes, numero, gmi80, date, espece_id, ligneboite, construitpar, construction, rdate, numeroboite, id, code, parents, colonneboite FROM souche
	});
    $sth->execute;
    while (($proprietes, $numero, $gmi80, $date, $espece_id, $ligneboite, $construitpar, $construction, $rdate, $numeroboite, $id, $code, $parents, $colonneboite) = $sth->fetchrow_array) {
	my $souche = {
		'proprietes' => $proprietes, 
		'numero' => $numero, 
		'gmi80' => $gmi80, 
		'date' => $date, 
		'espece_id' => $espece_id, 
		'ligneboite' => $ligneboite, 
		'construitpar' => $construitpar, 
		'construction' => $construction, 
		'rdate' => $rdate, 
		'numeroboite' => $numeroboite, 
		'id' => $id, 
		'code' => $code, 
		'parents' => $parents, 
		'colonneboite' => $colonneboite
		};
	bless($souche, $class);
	$souche{$code} = $souche;
    }
    $sth->finish;
    return(\%souche);
}

# create an object for already existing data
sub init_gmi80 {
    my ($class, $req_gmi80) = @_;
    # fetch the data from the database
    my $sth = $clism_DBH->prepare(qq {
	SELECT proprietes, numero, gmi80, date, espece_id, ligneboite, construitpar, construction, rdate, numeroboite, id, code, parents, colonneboite FROM souche
		WHERE gmi80='$req_gmi80'
	});
    $sth->execute;
    my ($proprietes, $numero, $gmi80, $date, $espece_id, $ligneboite, $construitpar, $construction, $rdate, $numeroboite, $id, $code, $parents, $colonneboite) = $sth->fetchrow_array;
    $sth->finish;
    # if successful, return an appropriate object
    if (!defined($id)) {
	return(-1);
    } else {
	my $souche = {
		'proprietes' => $proprietes, 
		'numero' => $numero, 
		'gmi80' => $gmi80, 
		'date' => $date, 
		'espece_id' => $espece_id, 
		'ligneboite' => $ligneboite, 
		'construitpar' => $construitpar, 
		'construction' => $construction, 
		'rdate' => $rdate, 
		'numeroboite' => $numeroboite, 
		'id' => $id, 
		'code' => $code, 
		'parents' => $parents, 
		'colonneboite' => $colonneboite
		};
        bless($souche, $class);
        return($souche);
    }
}

# get all objects from the database efficiently and return a hash reference
sub fetchallby_gmi80 {
    my ($class) = @_;
    local %souche = ();
    my $sth = $clism_DBH->prepare(qq {
	SELECT proprietes, numero, gmi80, date, espece_id, ligneboite, construitpar, construction, rdate, numeroboite, id, code, parents, colonneboite FROM souche
	});
    $sth->execute;
    while (($proprietes, $numero, $gmi80, $date, $espece_id, $ligneboite, $construitpar, $construction, $rdate, $numeroboite, $id, $code, $parents, $colonneboite) = $sth->fetchrow_array) {
	my $souche = {
		'proprietes' => $proprietes, 
		'numero' => $numero, 
		'gmi80' => $gmi80, 
		'date' => $date, 
		'espece_id' => $espece_id, 
		'ligneboite' => $ligneboite, 
		'construitpar' => $construitpar, 
		'construction' => $construction, 
		'rdate' => $rdate, 
		'numeroboite' => $numeroboite, 
		'id' => $id, 
		'code' => $code, 
		'parents' => $parents, 
		'colonneboite' => $colonneboite
		};
	bless($souche, $class);
	$souche{$gmi80} = $souche;
    }
    $sth->finish;
    return(\%souche);
}

# get all those objects from the database efficiently that conform to the
# given WHERE clause and return an array reference
sub fetchbySQL {
    my ($class, $statement) = @_;
    local @souche = ();
    my $sth = $clism_DBH->prepare(qq {
	SELECT proprietes, numero, gmi80, date, espece_id, ligneboite, construitpar, construction, rdate, numeroboite, id, code, parents, colonneboite FROM souche WHERE $statement
	});
    $sth->execute;
    while (($proprietes, $numero, $gmi80, $date, $espece_id, $ligneboite, $construitpar, $construction, $rdate, $numeroboite, $id, $code, $parents, $colonneboite) = $sth->fetchrow_array) {
	my $souche = {
		'proprietes' => $proprietes, 
		'numero' => $numero, 
		'gmi80' => $gmi80, 
		'date' => $date, 
		'espece_id' => $espece_id, 
		'ligneboite' => $ligneboite, 
		'construitpar' => $construitpar, 
		'construction' => $construction, 
		'rdate' => $rdate, 
		'numeroboite' => $numeroboite, 
		'id' => $id, 
		'code' => $code, 
		'parents' => $parents, 
		'colonneboite' => $colonneboite
		};
	bless($souche, $class);
	push(@souche, $souche);
    }
    $sth->finish;
    return(\@souche);
}

# get all objects from the database efficiently and return an array reference
sub fetchall {
    my ($class) = @_;
    local @souche = ();
    my $sth = $clism_DBH->prepare(qq {
	SELECT proprietes, numero, gmi80, date, espece_id, ligneboite, construitpar, construction, rdate, numeroboite, id, code, parents, colonneboite FROM souche
	});
    $sth->execute;
    while (($proprietes, $numero, $gmi80, $date, $espece_id, $ligneboite, $construitpar, $construction, $rdate, $numeroboite, $id, $code, $parents, $colonneboite) = $sth->fetchrow_array) {
	my $souche = {
		'proprietes' => $proprietes, 
		'numero' => $numero, 
		'gmi80' => $gmi80, 
		'date' => $date, 
		'espece_id' => $espece_id, 
		'ligneboite' => $ligneboite, 
		'construitpar' => $construitpar, 
		'construction' => $construction, 
		'rdate' => $rdate, 
		'numeroboite' => $numeroboite, 
		'id' => $id, 
		'code' => $code, 
		'parents' => $parents, 
		'colonneboite' => $colonneboite
		};
	bless($souche, $class);
	push(@souche, $souche);
    }
    $sth->finish;
    return(\@souche);
}

# delete an object completely from the database
sub delete {
    my ($self) = @_;
    my $id = $self->id;
    $clism_DBH->do(qq {
	DELETE FROM souche WHERE id=$id
	}) || return(-1);
    undef($self);
}

########################################################################
#
# methods to access the member variables
#
########################################################################

# get or set the member variable 'proprietes'
sub proprietes {
    my ($self, $proprietes) = @_;
    return($self->getset('proprietes', $proprietes));
}

# get or set the member variable 'numero'
sub numero {
    my ($self, $numero) = @_;
    return($self->getset('numero', $numero));
}

# get or set the member variable 'gmi80'
sub gmi80 {
    my ($self, $gmi80) = @_;
    return($self->getset('gmi80', $gmi80));
}

# get or set the member variable 'date'
sub date {
    my ($self, $date) = @_;
    return($self->getset('date', $date));
}

# get or set the member variable 'espece_id'
sub espece_id {
    my ($self, $espece_id) = @_;
    return($self->getset('espece_id', $espece_id));
}

# get or set the member variable 'ligneboite'
sub ligneboite {
    my ($self, $ligneboite) = @_;
    return($self->getset('ligneboite', $ligneboite));
}

# get or set the member variable 'construitpar'
sub construitpar {
    my ($self, $construitpar) = @_;
    return($self->getset('construitpar', $construitpar));
}

# get or set the member variable 'construction'
sub construction {
    my ($self, $construction) = @_;
    return($self->getset('construction', $construction));
}

# get or set the member variable 'rdate'
sub rdate {
    my ($self, $rdate) = @_;
    return($self->getset('rdate', $rdate));
}

# get or set the member variable 'numeroboite'
sub numeroboite {
    my ($self, $numeroboite) = @_;
    return($self->getset('numeroboite', $numeroboite));
}

# get the member variable 'id'
sub id {
    my ($self) = @_;
    return($self->{'id'});
}

# get or set the member variable 'code'
sub code {
    my ($self, $code) = @_;
    return($self->getset('code', $code));
}

# get or set the member variable 'parents'
sub parents {
    my ($self, $parents) = @_;
    return($self->getset('parents', $parents));
}

# get or set the member variable 'colonneboite'
sub colonneboite {
    my ($self, $colonneboite) = @_;
    return($self->getset('colonneboite', $colonneboite));
}

# set several member variables at the same time
sub mset {
    my ($self, $hashref) = @_;
    my $curbuffer = $self->buffered;
    $self->buffer;
    foreach $key (keys(%$hashref)) {
	# prevent really stupid tricks
	if ($key eq 'id') {
	    return(-1);
	}
	my $val = $hashref->{$key};
	&$key($self, $val);
    }
    if (!$curbuffer) {
	$self->unbuffer;
    }
}

########################################################################
#
# load additional methods from self made module
#
########################################################################

#require clism::souche_add;

########################################################################
#
# private functions used inside this module
#
########################################################################

# test if the data is buffered or passed to the DBMS immediately
sub buffered {
    my ($self) = @_;
    return($self->{'_buffer'});
}

# make the data buffered, i.e. don't write to the database
sub buffer {
    my ($self) = @_;
    $self->{'_buffer'} = 1;
}

# write the current contents to the database and declare the object unbuffered
sub unbuffer {
    my ($self) = @_;
    if ($self->buffered) {
	my @sql = ();
	foreach $key (qw{proprietes numero gmi80 date espece_id ligneboite construitpar construction rdate numeroboite id code parents colonneboite}) {
	    push(@sql, "$key=".$clism_DBH->quote($self->{$key}));
	}
	my $id = $self->id;
	my $sql = "UPDATE souche SET ".join(', ', @sql)." WHERE id=$id";
	$clism_DBH->do($sql) || return(-1);
    }
    $self->{'_buffer'} = 0;
}

# get or set one of the member variables
sub getset {
    my ($self, $var, $val) = @_;
    my $id = $self->id;
    if (defined($val)) {
	if (!$self->buffered) {
	    my $qval = $clism_DBH->quote($val);
	    $clism_DBH->do(qq {
		UPDATE souche SET $var=$qval WHERE id=$id
		}) || return(-1);
	}
	$self->{$var} = $val;
    }
    return($self->{$var});
}

