########################################################################
#
# This module was created automagically by O2DBI (1.24)
# Do not modify this file, changes will be lost!!!
#
# Additional methods can be defined in the file clism::transposon_plasmide_add.pm.
#
########################################################################

package clism::transposon_plasmide;

use clism::DBMS;

1;

########################################################################
#
# constructor and destructor methods for transposon_plasmide
#
########################################################################

# create a new object and insert it into the database
sub create {
    my ($class, $transposon_id, $plasmide_id) = @_;
    # fetch a fresh id
    my $id = newid('transposon_plasmide');
        if ($id < 0) {
	return(-1);
    }
    # insert the primary key into the database
    $clism_DBH->do(qq {
            INSERT INTO transposon_plasmide (id) VALUES ($id)
           });
    if ($clism_DBH->err) {
	return(-1);
    }
    # create the perl object
    my $transposon_plasmide = { 'id' => $id,
		    '_buffer' => 1 };
    bless($transposon_plasmide, $class);
    # fill in the remaining data
    $transposon_plasmide->transposon_id($transposon_id);
    $transposon_plasmide->plasmide_id($plasmide_id);
    if ($transposon_plasmide->unbuffer < 0) {
	$transposon_plasmide->delete;
	return(-1);
    } else {
	return($transposon_plasmide);
    }
}

# create an object for already existing data
sub init_id {
    my ($class, $req_id) = @_;
    # fetch the data from the database
    my $sth = $clism_DBH->prepare(qq {
	SELECT plasmide_id, transposon_id, id FROM transposon_plasmide
		WHERE id='$req_id'
	});
    $sth->execute;
    my ($plasmide_id, $transposon_id, $id) = $sth->fetchrow_array;
    $sth->finish;
    # if successful, return an appropriate object
    if (!defined($id)) {
	return(-1);
    } else {
	my $transposon_plasmide = {
		'plasmide_id' => $plasmide_id, 
		'transposon_id' => $transposon_id, 
		'id' => $id
		};
        bless($transposon_plasmide, $class);
        return($transposon_plasmide);
    }
}

# get all objects from the database efficiently and return a hash reference
sub fetchallby_id {
    my ($class) = @_;
    local %transposon_plasmide = ();
    my $sth = $clism_DBH->prepare(qq {
	SELECT plasmide_id, transposon_id, id FROM transposon_plasmide
	});
    $sth->execute;
    while (($plasmide_id, $transposon_id, $id) = $sth->fetchrow_array) {
	my $transposon_plasmide = {
		'plasmide_id' => $plasmide_id, 
		'transposon_id' => $transposon_id, 
		'id' => $id
		};
	bless($transposon_plasmide, $class);
	$transposon_plasmide{$id} = $transposon_plasmide;
    }
    $sth->finish;
    return(\%transposon_plasmide);
}

# create an object for already existing data
sub init_transposon_id_plasmide_id {
    my ($class, $req_transposon_id, $req_plasmide_id) = @_;
    # fetch the data from the database
    my $sth = $clism_DBH->prepare(qq {
	SELECT plasmide_id, transposon_id, id FROM transposon_plasmide
		WHERE transposon_id='$req_transposon_id' AND plasmide_id='$req_plasmide_id'
	});
    $sth->execute;
    my ($plasmide_id, $transposon_id, $id) = $sth->fetchrow_array;
    $sth->finish;
    # if successful, return an appropriate object
    if (!defined($id)) {
	return(-1);
    } else {
	my $transposon_plasmide = {
		'plasmide_id' => $plasmide_id, 
		'transposon_id' => $transposon_id, 
		'id' => $id
		};
        bless($transposon_plasmide, $class);
        return($transposon_plasmide);
    }
}

# get all objects from the database efficiently and return a hash reference
sub fetchallby_transposon_id_plasmide_id {
    my ($class) = @_;
    local %transposon_plasmide = ();
    my $sth = $clism_DBH->prepare(qq {
	SELECT plasmide_id, transposon_id, id FROM transposon_plasmide
	});
    $sth->execute;
    while (($plasmide_id, $transposon_id, $id) = $sth->fetchrow_array) {
	my $transposon_plasmide = {
		'plasmide_id' => $plasmide_id, 
		'transposon_id' => $transposon_id, 
		'id' => $id
		};
	bless($transposon_plasmide, $class);
	my $key = join(',', $transposon_id, $plasmide_id);
	$transposon_plasmide{$key} = $transposon_plasmide;
    }
    $sth->finish;
    return(\%transposon_plasmide);
}

# get all those objects from the database efficiently that conform to the
# given WHERE clause and return an array reference
sub fetchbySQL {
    my ($class, $statement) = @_;
    local @transposon_plasmide = ();
    my $sth = $clism_DBH->prepare(qq {
	SELECT plasmide_id, transposon_id, id FROM transposon_plasmide WHERE $statement
	});
    $sth->execute;
    while (($plasmide_id, $transposon_id, $id) = $sth->fetchrow_array) {
	my $transposon_plasmide = {
		'plasmide_id' => $plasmide_id, 
		'transposon_id' => $transposon_id, 
		'id' => $id
		};
	bless($transposon_plasmide, $class);
	push(@transposon_plasmide, $transposon_plasmide);
    }
    $sth->finish;
    return(\@transposon_plasmide);
}

# get all objects from the database efficiently and return an array reference
sub fetchall {
    my ($class) = @_;
    local @transposon_plasmide = ();
    my $sth = $clism_DBH->prepare(qq {
	SELECT plasmide_id, transposon_id, id FROM transposon_plasmide
	});
    $sth->execute;
    while (($plasmide_id, $transposon_id, $id) = $sth->fetchrow_array) {
	my $transposon_plasmide = {
		'plasmide_id' => $plasmide_id, 
		'transposon_id' => $transposon_id, 
		'id' => $id
		};
	bless($transposon_plasmide, $class);
	push(@transposon_plasmide, $transposon_plasmide);
    }
    $sth->finish;
    return(\@transposon_plasmide);
}

# delete an object completely from the database
sub delete {
    my ($self) = @_;
    my $id = $self->id;
    $clism_DBH->do(qq {
	DELETE FROM transposon_plasmide WHERE id=$id
	}) || return(-1);
    undef($self);
}

########################################################################
#
# methods to access the member variables
#
########################################################################

# get or set the member variable 'plasmide_id'
sub plasmide_id {
    my ($self, $plasmide_id) = @_;
    return($self->getset('plasmide_id', $plasmide_id));
}

# get or set the member variable 'transposon_id'
sub transposon_id {
    my ($self, $transposon_id) = @_;
    return($self->getset('transposon_id', $transposon_id));
}

# get the member variable 'id'
sub id {
    my ($self) = @_;
    return($self->{'id'});
}

# set several member variables at the same time
sub mset {
    my ($self, $hashref) = @_;
    my $curbuffer = $self->buffered;
    $self->buffer;
    foreach $key (keys(%$hashref)) {
	# prevent really stupid tricks
	if ($key eq 'id') {
	    return(-1);
	}
	my $val = $hashref->{$key};
	&$key($self, $val);
    }
    if (!$curbuffer) {
	$self->unbuffer;
    }
}

########################################################################
#
# load additional methods from self made module
#
########################################################################

#require clism::transposon_plasmide_add;

########################################################################
#
# private functions used inside this module
#
########################################################################

# test if the data is buffered or passed to the DBMS immediately
sub buffered {
    my ($self) = @_;
    return($self->{'_buffer'});
}

# make the data buffered, i.e. don't write to the database
sub buffer {
    my ($self) = @_;
    $self->{'_buffer'} = 1;
}

# write the current contents to the database and declare the object unbuffered
sub unbuffer {
    my ($self) = @_;
    if ($self->buffered) {
	my @sql = ();
	foreach $key (qw{plasmide_id transposon_id id}) {
	    push(@sql, "$key=".$clism_DBH->quote($self->{$key}));
	}
	my $id = $self->id;
	my $sql = "UPDATE transposon_plasmide SET ".join(', ', @sql)." WHERE id=$id";
	$clism_DBH->do($sql) || return(-1);
    }
    $self->{'_buffer'} = 0;
}

# get or set one of the member variables
sub getset {
    my ($self, $var, $val) = @_;
    my $id = $self->id;
    if (defined($val)) {
	if (!$self->buffered) {
	    my $qval = $clism_DBH->quote($val);
	    $clism_DBH->do(qq {
		UPDATE transposon_plasmide SET $var=$qval WHERE id=$id
		}) || return(-1);
	}
	$self->{$var} = $val;
    }
    return($self->{$var});
}

