
--
-- Name: CLISM; Type: DATABASE; Schema: -; Owner: postgres
--

\connect CLISM

SET default_with_oids = false;

--
-- Name: antibios; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE antibios (
    souche_id integer,
    concentration character varying(15),
    caracterep_id integer,
    commentaire character varying(80),
    id integer NOT NULL
);


ALTER TABLE public.antibios OWNER TO CLISM;

--
-- Name: TABLE antibios; Type: COMMENT; Schema: public; Owner: CLISM
--

COMMENT ON TABLE antibios IS 'jointure caracterep=>souche + autres champs - DEVRAIT S''APPELER phenotype';


--
-- Name: biblio; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE biblio (
    revue_id integer,
    numero integer,
    volume character varying(80),
    titre text,
    annee integer,
    motscles text,
    editeur_id integer,
    url character varying(255),
    auteurs text,
    id integer NOT NULL,
    livre text,
    pages character varying(80)
);


ALTER TABLE public.biblio OWNER TO CLISM;

--
-- Name: TABLE biblio; Type: COMMENT; Schema: public; Owner: CLISM
--

COMMENT ON TABLE biblio IS 'LA BIBLIO';


--
-- Name: biblio_plasmide; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE biblio_plasmide (
    plasmide_id integer,
    biblio_id integer,
    id integer NOT NULL
);


ALTER TABLE public.biblio_plasmide OWNER TO CLISM;

--
-- Name: TABLE biblio_plasmide; Type: COMMENT; Schema: public; Owner: CLISM
--

COMMENT ON TABLE biblio_plasmide IS 'Table de jointure';


--
-- Name: biblio_souche; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE biblio_souche (
    souche_id integer,
    biblio_id integer,
    id integer NOT NULL
);


ALTER TABLE public.biblio_souche OWNER TO CLISM;

--
-- Name: TABLE biblio_souche; Type: COMMENT; Schema: public; Owner: CLISM
--

COMMENT ON TABLE biblio_souche IS 'Table de jointure';


--
-- Name: caractere; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE caractere (
    nom character varying(80),
    id integer NOT NULL,
    description text
);


ALTER TABLE public.caractere OWNER TO CLISM;

--
-- Name: TABLE caractere; Type: COMMENT; Schema: public; Owner: CLISM
--

COMMENT ON TABLE caractere IS 'Caractere genotypique';


--
-- Name: caractere_plasmide; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE caractere_plasmide (
    plasmide_id integer,
    id integer NOT NULL,
    caractere_id integer
);


ALTER TABLE public.caractere_plasmide OWNER TO CLISM;

--
-- Name: TABLE caractere_plasmide; Type: COMMENT; Schema: public; Owner: CLISM
--

COMMENT ON TABLE caractere_plasmide IS 'Table de jointure';


--
-- Name: caractere_souche; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE caractere_souche (
    souche_id integer,
    id integer NOT NULL,
    caractere_id integer
);


ALTER TABLE public.caractere_souche OWNER TO CLISM;

--
-- Name: TABLE caractere_souche; Type: COMMENT; Schema: public; Owner: CLISM
--

COMMENT ON TABLE caractere_souche IS 'Table de jointure';


--
-- Name: caracterea; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE caracterea (
    nom character varying(80),
    id integer NOT NULL,
    description text
);


ALTER TABLE public.caracterea OWNER TO CLISM;

--
-- Name: TABLE caracterea; Type: COMMENT; Schema: public; Owner: CLISM
--

COMMENT ON TABLE caracterea IS 'Caractere auxotrophique';


--
-- Name: caracterea_souche; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE caracterea_souche (
    souche_id integer,
    caracterea_id integer,
    id integer NOT NULL
);


ALTER TABLE public.caracterea_souche OWNER TO CLISM;

--
-- Name: TABLE caracterea_souche; Type: COMMENT; Schema: public; Owner: CLISM
--

COMMENT ON TABLE caracterea_souche IS 'Table de jointure';


--
-- Name: caracterep; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE caracterep (
    nom character varying(80),
    id integer NOT NULL,
    description text,
    antibio boolean DEFAULT false
);


ALTER TABLE public.caracterep OWNER TO CLISM;

--
-- Name: TABLE caracterep; Type: COMMENT; Schema: public; Owner: CLISM
--

COMMENT ON TABLE caracterep IS 'Caractere phenotypique';


--
-- Name: clism_counters; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE clism_counters (
    object character(30),
    val integer
);


ALTER TABLE public.clism_counters OWNER TO CLISM;

--
-- Name: editeur; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE editeur (
    nom character varying(80),
    id integer NOT NULL
);


ALTER TABLE public.editeur OWNER TO CLISM;

--
-- Name: espece; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE espece (
    nom character varying(80),
    id integer NOT NULL
);


ALTER TABLE public.espece OWNER TO CLISM;

--
-- Name: fragment; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE fragment (
    source character varying(80),
    siterestriction_id integer,
    plasmide_id integer,
    taille real,
    id integer
);


ALTER TABLE public.fragment OWNER TO CLISM;

--
-- Name: TABLE fragment; Type: COMMENT; Schema: public; Owner: CLISM
--

COMMENT ON TABLE fragment IS 'taille, site de restriction, jointure vers plasmide';


--
-- Name: gene; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE gene (
    nom character varying(80),
    id integer NOT NULL,
    description text
);


ALTER TABLE public.gene OWNER TO CLISM;

--
-- Name: gene_plasmide; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE gene_plasmide (
    gene_id integer,
    plasmide_id integer,
    id integer NOT NULL
);


ALTER TABLE public.gene_plasmide OWNER TO CLISM;

--
-- Name: gene_souche; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE gene_souche (
    gene_id integer,
    souche_id integer,
    id integer NOT NULL
);


ALTER TABLE public.gene_souche OWNER TO CLISM;

--
-- Name: nom_plasmide; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE nom_plasmide (
    nom text,
    plasmide_id integer,
    id integer NOT NULL
);


ALTER TABLE public.nom_plasmide OWNER TO CLISM;

--
-- Name: nom_souche; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE nom_souche (
    nom text,
    souche_id integer,
    id integer NOT NULL
);


ALTER TABLE public.nom_souche OWNER TO CLISM;

--
-- Name: phenotypeconfere; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE phenotypeconfere (
    concentration character varying(15),
    plasmide_id integer,
    caracterep_id integer,
    commentaire character varying(80),
    id integer NOT NULL
);


ALTER TABLE public.phenotypeconfere OWNER TO CLISM;

--
-- Name: TABLE phenotypeconfere; Type: COMMENT; Schema: public; Owner: CLISM
--

COMMENT ON TABLE phenotypeconfere IS 'jointure caracterep=>plasmide + autres champs';


--
-- Name: plasmide; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE plasmide (
    groupeincompatibilite text,
    vnti_jpg bytea,
    numero integer,
    vnti_gb bytea,
    construitpar character varying(80),
    construction text,
    derivede character varying(80),
    taille real,
    id integer NOT NULL,
    code character varying(20),
    carterestriction text,
    vecteur_id integer
);


ALTER TABLE public.plasmide OWNER TO CLISM;

--
-- Name: TABLE plasmide; Type: COMMENT; Schema: public; Owner: CLISM
--

COMMENT ON TABLE plasmide IS 'LES PLASMIDES';


--
-- Name: COLUMN plasmide.vnti_jpg; Type: COMMENT; Schema: public; Owner: CLISM
--

COMMENT ON COLUMN plasmide.vnti_jpg IS 'fichier vector nti exporte en jpeg';


--
-- Name: COLUMN plasmide.vnti_gb; Type: COMMENT; Schema: public; Owner: CLISM
--

COMMENT ON COLUMN plasmide.vnti_gb IS 'fichier vector nti natif';


--
-- Name: plasmide_souche; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE plasmide_souche (
    souche_id integer,
    plasmide_id integer,
    id integer NOT NULL
);


ALTER TABLE public.plasmide_souche OWNER TO CLISM;

--
-- Name: revue; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE revue (
    nom character varying(80),
    id integer NOT NULL
);


ALTER TABLE public.revue OWNER TO CLISM;

--
-- Name: siterestriction; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE siterestriction (
    nom character varying(80),
    id integer NOT NULL,
    description text
);


ALTER TABLE public.siterestriction OWNER TO CLISM;

--
-- Name: souche; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE souche (
    proprietes text,
    date date,
    ligneboite integer,
    construitpar character varying(80),
    id integer NOT NULL,
    code character varying(20),
    numero integer,
    gmi80 character varying(20),
    espece_id integer,
    construction text,
    numeroboite character varying(10),
    colonneboite character(1),
    parents character varying(80),
    rdate date
);


ALTER TABLE public.souche OWNER TO CLISM;

--
-- Name: TABLE souche; Type: COMMENT; Schema: public; Owner: CLISM
--

COMMENT ON TABLE souche IS 'LES SOUCHES';


--
-- Name: COLUMN souche.date; Type: COMMENT; Schema: public; Owner: CLISM
--

COMMENT ON COLUMN souche.date IS 'date de creation';


--
-- Name: COLUMN souche.numero; Type: COMMENT; Schema: public; Owner: CLISM
--

COMMENT ON COLUMN souche.numero IS 'cfism: Numero';


--
-- Name: COLUMN souche.gmi80; Type: COMMENT; Schema: public; Owner: CLISM
--

COMMENT ON COLUMN souche.gmi80 IS 'cfism: position dans le congelo';


--
-- Name: COLUMN souche.rdate; Type: COMMENT; Schema: public; Owner: CLISM
--

COMMENT ON COLUMN souche.rdate IS 'date de repiquage';


--
-- Name: transposon; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE transposon (
    nom character varying(80),
    id integer NOT NULL,
    description text
);


ALTER TABLE public.transposon OWNER TO CLISM;

--
-- Name: transposon_plasmide; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE transposon_plasmide (
    plasmide_id integer,
    transposon_id integer,
    id integer NOT NULL
);


ALTER TABLE public.transposon_plasmide OWNER TO CLISM;

--
-- Name: transposon_souche; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE transposon_souche (
    souche_id integer,
    transposon_id integer,
    id integer NOT NULL
);


ALTER TABLE public.transposon_souche OWNER TO CLISM;

--
-- Name: utilisateur; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE utilisateur (
    prefixe character(3),
    mail character varying(80),
    id integer NOT NULL,
    description character varying(80),
    login character varying(20)
);


ALTER TABLE public.utilisateur OWNER TO CLISM;

--
-- Name: vecteur; Type: TABLE; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE TABLE vecteur (
    id integer DEFAULT 0 NOT NULL,
    nom character varying(40)
);


ALTER TABLE public.vecteur OWNER TO CLISM;

--
-- Data for Name: antibios; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY antibios (souche_id, concentration, caracterep_id, commentaire, id) FROM stdin;
\.


--
-- Data for Name: biblio; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY biblio (revue_id, numero, volume, titre, annee, motscles, editeur_id, url, auteurs, id, livre, pages) FROM stdin;
\.


--
-- Data for Name: biblio_plasmide; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY biblio_plasmide (plasmide_id, biblio_id, id) FROM stdin;
\.


--
-- Data for Name: biblio_souche; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY biblio_souche (souche_id, biblio_id, id) FROM stdin;
\.


--
-- Data for Name: caractere; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY caractere (nom, id, description) FROM stdin;
TetR	3	\N
TetS	4	\N
NeoR	5	\N
NeoS	6	\N
AmpR	1	\N
AmpS	2	\N
\.


--
-- Data for Name: caractere_plasmide; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY caractere_plasmide (plasmide_id, id, caractere_id) FROM stdin;
\.


--
-- Data for Name: caractere_souche; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY caractere_souche (souche_id, id, caractere_id) FROM stdin;
\.


--
-- Data for Name: caracterea; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY caracterea (nom, id, description) FROM stdin;
hsdM+	1	\N
hsdR-	2	\N
Lac-	3	\N
Lac+	4	\N
RecA-	5	\N
\.


--
-- Data for Name: caracterea_souche; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY caracterea_souche (souche_id, caracterea_id, id) FROM stdin;
\.


--
-- Data for Name: caracterep; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY caracterep (nom, id, description, antibio) FROM stdin;
TetR	3		t
TetS	4		t
NeoR	5		t
NeoS	6		t
AmpR	1		t
AmpS	2		t
\.


--
-- Data for Name: clism_counters; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY clism_counters (object, val) FROM stdin;
siterestriction	6
editeur	4
revue	4
caracterep	6
transposon_plasmide	0
transposon	3
caractere_plasmide	0
caracterea	5
biblio_plasmide	0
phenotypeconfere	0
caractere	6
gene_plasmide	0
fragment	0
espece	1
gene	3
souche	0
nom_souche	0
plasmide_souche	0
antibios	0
gene_souche	0
biblio_souche	0
biblio	0
caracterea_souche	0
transposon_souche	0
caractere_souche	0
utilisateur	1
plasmide	0
nom_plasmide	0
vecteur	10
\.


--
-- Data for Name: editeur; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY editeur (nom, id) FROM stdin;
INRA	1
SFM	2
Academic Press	3
Elsevier Biomedical	4
\.


--
-- Data for Name: espece; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY espece (nom, id) FROM stdin;
Escherichia coli 	1
\.


--
-- Data for Name: fragment; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY fragment (source, siterestriction_id, plasmide_id, taille, id) FROM stdin;
\.


--
-- Data for Name: gene; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY gene (nom, id, description) FROM stdin;
gfp	1	\N
lacZ	2	\N
gus	3	\N
\.

--
-- Data for Name: gene_plasmide; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY gene_plasmide (gene_id, plasmide_id, id) FROM stdin;
\.


--
-- Data for Name: gene_souche; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY gene_souche (gene_id, souche_id, id) FROM stdin;
\.


--
-- Data for Name: nom_plasmide; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY nom_plasmide (nom, plasmide_id, id) FROM stdin;
\.


--
-- Data for Name: nom_souche; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY nom_souche (nom, souche_id, id) FROM stdin;
\.


--
-- Data for Name: phenotypeconfere; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY phenotypeconfere (concentration, plasmide_id, caracterep_id, commentaire, id) FROM stdin;
\.


--
-- Data for Name: plasmide; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY plasmide (groupeincompatibilite, vnti_jpg, numero, vnti_gb, construitpar, construction, derivede, taille, id, code, carterestriction, vecteur_id) FROM stdin;
\.


--
-- Data for Name: plasmide_souche; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY plasmide_souche (souche_id, plasmide_id, id) FROM stdin;
\.


--
-- Data for Name: revue; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY revue (nom, id) FROM stdin;
Inconnue	0
EMBO Journal	1
Cell	2
P.N.A.S.	3
Nature	4
\.


--
-- Data for Name: siterestriction; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY siterestriction (nom, id, description) FROM stdin;
bamH1	1	\N
EcoR1	2	\N
HindIII	3	\N
BamH1-HindIII	4	\N
BamH1-EcoR1	5	\N
EcoR1-HindIII	6	\N
\.


--
-- Data for Name: souche; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY souche (proprietes, date, ligneboite, construitpar, id, code, numero, gmi80, espece_id, construction, numeroboite, colonneboite, parents, rdate) FROM stdin;
\.


--
-- Data for Name: transposon; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY transposon (nom, id, description) FROM stdin;
Tn5	1	\N
Tn7	2	\N
Tn5-lacZ	3	\N
\.


--
-- Data for Name: transposon_plasmide; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY transposon_plasmide (plasmide_id, transposon_id, id) FROM stdin;
\.


--
-- Data for Name: transposon_souche; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY transposon_souche (souche_id, transposon_id, id) FROM stdin;
\.


--
-- Data for Name: utilisateur; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY utilisateur (prefixe, mail, id, description, login) FROM stdin;
PRE	ADMINMAIL	1	ADMINDESC	ADMIN
\.


--
-- Data for Name: vecteur; Type: TABLE DATA; Schema: public; Owner: CLISM
--

COPY vecteur (id, nom) FROM stdin;
0	none
1	Mammalian cells expression vector
2	Helper vector
3	Single stranded plasmids
4	pCambia family
5	pGreen family
6	Bacterial expression vector with fusion
7	Bacterial expression vector
8	Cloning vector
9	Mutagenesis vector
10	Yeast expression vector
\.


--
-- Name: antibios_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY antibios
    ADD CONSTRAINT antibios_pkey PRIMARY KEY (id);


--
-- Name: biblio_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY biblio
    ADD CONSTRAINT biblio_pkey PRIMARY KEY (id);


--
-- Name: biblio_plasmide_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY biblio_plasmide
    ADD CONSTRAINT biblio_plasmide_pkey PRIMARY KEY (id);


--
-- Name: biblio_souche_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY biblio_souche
    ADD CONSTRAINT biblio_souche_pkey PRIMARY KEY (id);


--
-- Name: caractere_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY caractere
    ADD CONSTRAINT caractere_pkey PRIMARY KEY (id);


--
-- Name: caractere_plasmide_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY caractere_plasmide
    ADD CONSTRAINT caractere_plasmide_pkey PRIMARY KEY (id);


--
-- Name: caractere_souche_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY caractere_souche
    ADD CONSTRAINT caractere_souche_pkey PRIMARY KEY (id);


--
-- Name: caracterea_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY caracterea
    ADD CONSTRAINT caracterea_pkey PRIMARY KEY (id);


--
-- Name: caracterea_souche_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY caracterea_souche
    ADD CONSTRAINT caracterea_souche_pkey PRIMARY KEY (id);


--
-- Name: caracterep_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY caracterep
    ADD CONSTRAINT caracterep_pkey PRIMARY KEY (id);


--
-- Name: editeur_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY editeur
    ADD CONSTRAINT editeur_pkey PRIMARY KEY (id);


--
-- Name: espece_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY espece
    ADD CONSTRAINT espece_pkey PRIMARY KEY (id);


--
-- Name: gene_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY gene
    ADD CONSTRAINT gene_pkey PRIMARY KEY (id);


--
-- Name: gene_plasmide_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY gene_plasmide
    ADD CONSTRAINT gene_plasmide_pkey PRIMARY KEY (id);


--
-- Name: gene_souche_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY gene_souche
    ADD CONSTRAINT gene_souche_pkey PRIMARY KEY (id);


--
-- Name: nom_plasmide_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY nom_plasmide
    ADD CONSTRAINT nom_plasmide_pkey PRIMARY KEY (id);


--
-- Name: nom_souche_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY nom_souche
    ADD CONSTRAINT nom_souche_pkey PRIMARY KEY (id);


--
-- Name: phenotypeconfere_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY phenotypeconfere
    ADD CONSTRAINT phenotypeconfere_pkey PRIMARY KEY (id);


--
-- Name: plasmide_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY plasmide
    ADD CONSTRAINT plasmide_pkey PRIMARY KEY (id);


--
-- Name: plasmide_souche_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY plasmide_souche
    ADD CONSTRAINT plasmide_souche_pkey PRIMARY KEY (id);


--
-- Name: revue_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY revue
    ADD CONSTRAINT revue_pkey PRIMARY KEY (id);


--
-- Name: siterestriction_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY siterestriction
    ADD CONSTRAINT siterestriction_pkey PRIMARY KEY (id);


--
-- Name: souche_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY souche
    ADD CONSTRAINT souche_pkey PRIMARY KEY (id);


--
-- Name: transposon_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY transposon
    ADD CONSTRAINT transposon_pkey PRIMARY KEY (id);


--
-- Name: transposon_plasmide_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY transposon_plasmide
    ADD CONSTRAINT transposon_plasmide_pkey PRIMARY KEY (id);


--
-- Name: transposon_souche_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY transposon_souche
    ADD CONSTRAINT transposon_souche_pkey PRIMARY KEY (id);


--
-- Name: un10; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY nom_souche
    ADD CONSTRAINT un10 UNIQUE (nom);


--
-- Name: un20; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY nom_plasmide
    ADD CONSTRAINT un20 UNIQUE (nom);


--
-- Name: utilisateur_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY utilisateur
    ADD CONSTRAINT utilisateur_pkey PRIMARY KEY (id);


--
-- Name: vecteur_pkey; Type: CONSTRAINT; Schema: public; Owner: CLISM; Tablespace: 
--

ALTER TABLE ONLY vecteur
    ADD CONSTRAINT vecteur_pkey PRIMARY KEY (id);


--
-- Name: antibios_caracterep_id_souche_id_key; Type: INDEX; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE UNIQUE INDEX antibios_caracterep_id_souche_id_key ON antibios USING btree (caracterep_id, souche_id);


--
-- Name: biblio_plasmide_biblio_id_plasmide_id_key; Type: INDEX; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE UNIQUE INDEX biblio_plasmide_biblio_id_plasmide_id_key ON biblio_plasmide USING btree (biblio_id, plasmide_id);


--
-- Name: biblio_souche_biblio_id_souche_id_key; Type: INDEX; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE UNIQUE INDEX biblio_souche_biblio_id_souche_id_key ON biblio_souche USING btree (biblio_id, souche_id);


--
-- Name: caractere_nom_key; Type: INDEX; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE UNIQUE INDEX caractere_nom_key ON caractere USING btree (nom);


--
-- Name: caractere_plasmide_caractere_id_plasmide_id_key; Type: INDEX; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE UNIQUE INDEX caractere_plasmide_caractere_id_plasmide_id_key ON caractere_plasmide USING btree (caractere_id, plasmide_id);


--
-- Name: caractere_souche_caractere_id_souche_id_key; Type: INDEX; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE UNIQUE INDEX caractere_souche_caractere_id_souche_id_key ON caractere_souche USING btree (caractere_id, souche_id);


--
-- Name: caracterea_nom_key; Type: INDEX; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE UNIQUE INDEX caracterea_nom_key ON caracterea USING btree (nom);


--
-- Name: caracterea_souche_caracterea_id_souche_id_key; Type: INDEX; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE UNIQUE INDEX caracterea_souche_caracterea_id_souche_id_key ON caracterea_souche USING btree (caracterea_id, souche_id);


--
-- Name: caracterep_nom_key; Type: INDEX; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE UNIQUE INDEX caracterep_nom_key ON caracterep USING btree (nom);


--
-- Name: editeur_nom_key; Type: INDEX; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE UNIQUE INDEX editeur_nom_key ON editeur USING btree (nom);


--
-- Name: espece_nom_key; Type: INDEX; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE UNIQUE INDEX espece_nom_key ON espece USING btree (nom);


--
-- Name: gene_nom_key; Type: INDEX; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE UNIQUE INDEX gene_nom_key ON gene USING btree (nom);


--
-- Name: gene_plasmide_gene_id_plasmide_id_key; Type: INDEX; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE UNIQUE INDEX gene_plasmide_gene_id_plasmide_id_key ON gene_plasmide USING btree (gene_id, plasmide_id);


--
-- Name: gene_souche_gene_id_souche_id_key; Type: INDEX; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE UNIQUE INDEX gene_souche_gene_id_souche_id_key ON gene_souche USING btree (gene_id, souche_id);


--
-- Name: nom_plasmide_nom_key; Type: INDEX; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE UNIQUE INDEX nom_plasmide_nom_key ON nom_plasmide USING btree (nom);


--
-- Name: nom_souche_nom_key; Type: INDEX; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE UNIQUE INDEX nom_souche_nom_key ON nom_souche USING btree (nom);


--
-- Name: phenotypeconfere_caracterep_id_plasmide_id_key; Type: INDEX; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE UNIQUE INDEX phenotypeconfere_caracterep_id_plasmide_id_key ON phenotypeconfere USING btree (caracterep_id, plasmide_id);


--
-- Name: plasmide_code_key; Type: INDEX; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE UNIQUE INDEX plasmide_code_key ON plasmide USING btree (code);


--
-- Name: plasmide_souche_plasmide_id_souche_id_key; Type: INDEX; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE UNIQUE INDEX plasmide_souche_plasmide_id_souche_id_key ON plasmide_souche USING btree (plasmide_id, souche_id);


--
-- Name: revue_nom_key; Type: INDEX; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE UNIQUE INDEX revue_nom_key ON revue USING btree (nom);


--
-- Name: siterestriction_nom_key; Type: INDEX; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE UNIQUE INDEX siterestriction_nom_key ON siterestriction USING btree (nom);


--
-- Name: souche_code_key; Type: INDEX; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE UNIQUE INDEX souche_code_key ON souche USING btree (code);


--
-- Name: souche_gmi80_key; Type: INDEX; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE UNIQUE INDEX souche_gmi80_key ON souche USING btree (gmi80);


--
-- Name: transposon_nom_key; Type: INDEX; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE UNIQUE INDEX transposon_nom_key ON transposon USING btree (nom);


--
-- Name: transposon_plasmide_transposon_id_plasmide_id_key; Type: INDEX; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE UNIQUE INDEX transposon_plasmide_transposon_id_plasmide_id_key ON transposon_plasmide USING btree (transposon_id, plasmide_id);


--
-- Name: transposon_souche_transposon_id_souche_id_key; Type: INDEX; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE UNIQUE INDEX transposon_souche_transposon_id_souche_id_key ON transposon_souche USING btree (transposon_id, souche_id);


--
-- Name: utilisateur_login_key; Type: INDEX; Schema: public; Owner: CLISM; Tablespace: 
--

CREATE UNIQUE INDEX utilisateur_login_key ON utilisateur USING btree (login);


--
-- Name: fk10; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY souche
    ADD CONSTRAINT fk10 FOREIGN KEY (espece_id) REFERENCES espece(id) MATCH FULL;


--
-- Name: fk100; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY biblio_plasmide
    ADD CONSTRAINT fk100 FOREIGN KEY (biblio_id) REFERENCES biblio(id) MATCH FULL ON DELETE CASCADE;


--
-- Name: fk110; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY plasmide_souche
    ADD CONSTRAINT fk110 FOREIGN KEY (souche_id) REFERENCES souche(id) MATCH FULL ON DELETE CASCADE;


--
-- Name: fk120; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY plasmide_souche
    ADD CONSTRAINT fk120 FOREIGN KEY (plasmide_id) REFERENCES plasmide(id) MATCH FULL ON DELETE CASCADE;


--
-- Name: fk130; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY caractere_souche
    ADD CONSTRAINT fk130 FOREIGN KEY (souche_id) REFERENCES souche(id) MATCH FULL ON DELETE CASCADE;


--
-- Name: fk140; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY caractere_souche
    ADD CONSTRAINT fk140 FOREIGN KEY (caractere_id) REFERENCES caractere(id) MATCH FULL ON DELETE CASCADE;


--
-- Name: fk150; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY caractere_plasmide
    ADD CONSTRAINT fk150 FOREIGN KEY (plasmide_id) REFERENCES plasmide(id) MATCH FULL ON DELETE CASCADE;


--
-- Name: fk160; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY caractere_plasmide
    ADD CONSTRAINT fk160 FOREIGN KEY (caractere_id) REFERENCES caractere(id) MATCH FULL ON DELETE CASCADE;


--
-- Name: fk17; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY plasmide
    ADD CONSTRAINT fk17 FOREIGN KEY (vecteur_id) REFERENCES vecteur(id) MATCH FULL;


--
-- Name: fk170; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY antibios
    ADD CONSTRAINT fk170 FOREIGN KEY (caracterep_id) REFERENCES caracterep(id) MATCH FULL;


--
-- Name: fk180; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY antibios
    ADD CONSTRAINT fk180 FOREIGN KEY (souche_id) REFERENCES souche(id) MATCH FULL ON DELETE CASCADE;


--
-- Name: fk190; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY caracterea_souche
    ADD CONSTRAINT fk190 FOREIGN KEY (souche_id) REFERENCES souche(id) MATCH FULL ON DELETE CASCADE;


--
-- Name: fk20; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY biblio
    ADD CONSTRAINT fk20 FOREIGN KEY (revue_id) REFERENCES revue(id) MATCH FULL;


--
-- Name: fk200; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY caracterea_souche
    ADD CONSTRAINT fk200 FOREIGN KEY (caracterea_id) REFERENCES caracterea(id) MATCH FULL ON DELETE CASCADE;


--
-- Name: fk210; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY transposon_souche
    ADD CONSTRAINT fk210 FOREIGN KEY (transposon_id) REFERENCES transposon(id) MATCH FULL;


--
-- Name: fk220; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY transposon_souche
    ADD CONSTRAINT fk220 FOREIGN KEY (souche_id) REFERENCES souche(id) MATCH FULL ON DELETE CASCADE;


--
-- Name: fk230; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY transposon_plasmide
    ADD CONSTRAINT fk230 FOREIGN KEY (transposon_id) REFERENCES transposon(id) MATCH FULL;


--
-- Name: fk240; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY transposon_plasmide
    ADD CONSTRAINT fk240 FOREIGN KEY (plasmide_id) REFERENCES plasmide(id) MATCH FULL ON DELETE CASCADE;


--
-- Name: fk250; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY gene_souche
    ADD CONSTRAINT fk250 FOREIGN KEY (gene_id) REFERENCES gene(id) MATCH FULL;


--
-- Name: fk260; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY gene_souche
    ADD CONSTRAINT fk260 FOREIGN KEY (souche_id) REFERENCES souche(id) MATCH FULL ON DELETE CASCADE;


--
-- Name: fk270; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY gene_plasmide
    ADD CONSTRAINT fk270 FOREIGN KEY (gene_id) REFERENCES gene(id) MATCH FULL;


--
-- Name: fk280; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY gene_plasmide
    ADD CONSTRAINT fk280 FOREIGN KEY (plasmide_id) REFERENCES plasmide(id) MATCH FULL ON DELETE CASCADE;


--
-- Name: fk290; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY nom_souche
    ADD CONSTRAINT fk290 FOREIGN KEY (souche_id) REFERENCES souche(id) MATCH FULL ON DELETE CASCADE;


--
-- Name: fk30; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY biblio
    ADD CONSTRAINT fk30 FOREIGN KEY (editeur_id) REFERENCES editeur(id) MATCH FULL;


--
-- Name: fk300; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY nom_plasmide
    ADD CONSTRAINT fk300 FOREIGN KEY (plasmide_id) REFERENCES plasmide(id) MATCH FULL ON DELETE CASCADE;


--
-- Name: fk40; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY fragment
    ADD CONSTRAINT fk40 FOREIGN KEY (siterestriction_id) REFERENCES siterestriction(id) MATCH FULL;


--
-- Name: fk45; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY fragment
    ADD CONSTRAINT fk45 FOREIGN KEY (plasmide_id) REFERENCES plasmide(id) MATCH FULL ON DELETE CASCADE;


--
-- Name: fk50; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY phenotypeconfere
    ADD CONSTRAINT fk50 FOREIGN KEY (caracterep_id) REFERENCES caracterep(id) MATCH FULL;


--
-- Name: fk60; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY phenotypeconfere
    ADD CONSTRAINT fk60 FOREIGN KEY (plasmide_id) REFERENCES plasmide(id) MATCH FULL ON DELETE CASCADE;


--
-- Name: fk70; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY biblio_souche
    ADD CONSTRAINT fk70 FOREIGN KEY (biblio_id) REFERENCES biblio(id) MATCH FULL ON DELETE CASCADE;


--
-- Name: fk80; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY biblio_souche
    ADD CONSTRAINT fk80 FOREIGN KEY (souche_id) REFERENCES souche(id) MATCH FULL ON DELETE CASCADE;


--
-- Name: fk90; Type: FK CONSTRAINT; Schema: public; Owner: CLISM
--

ALTER TABLE ONLY biblio_plasmide
    ADD CONSTRAINT fk90 FOREIGN KEY (plasmide_id) REFERENCES plasmide(id) MATCH FULL ON DELETE CASCADE;


--
-- Name: public; Type: ACL; Schema: -; Owner: postgres
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM postgres;
GRANT ALL ON SCHEMA public TO postgres;
GRANT ALL ON SCHEMA public TO PUBLIC;


--
-- Name: antibios; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE antibios FROM PUBLIC;
REVOKE ALL ON TABLE antibios FROM CLISM;
GRANT ALL ON TABLE antibios TO CLISM;
GRANT SELECT ON TABLE antibios TO CLISM_all;


--
-- Name: biblio; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE biblio FROM PUBLIC;
REVOKE ALL ON TABLE biblio FROM CLISM;
GRANT ALL ON TABLE biblio TO CLISM;
GRANT SELECT ON TABLE biblio TO CLISM_all;


--
-- Name: biblio_plasmide; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE biblio_plasmide FROM PUBLIC;
REVOKE ALL ON TABLE biblio_plasmide FROM CLISM;
GRANT ALL ON TABLE biblio_plasmide TO CLISM;
GRANT SELECT ON TABLE biblio_plasmide TO CLISM_all;


--
-- Name: biblio_souche; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE biblio_souche FROM PUBLIC;
REVOKE ALL ON TABLE biblio_souche FROM CLISM;
GRANT ALL ON TABLE biblio_souche TO CLISM;
GRANT SELECT ON TABLE biblio_souche TO CLISM_all;


--
-- Name: caractere; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE caractere FROM PUBLIC;
REVOKE ALL ON TABLE caractere FROM CLISM;
GRANT ALL ON TABLE caractere TO CLISM;
GRANT SELECT ON TABLE caractere TO CLISM_all;


--
-- Name: caractere_plasmide; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE caractere_plasmide FROM PUBLIC;
REVOKE ALL ON TABLE caractere_plasmide FROM CLISM;
GRANT ALL ON TABLE caractere_plasmide TO CLISM;
GRANT SELECT ON TABLE caractere_plasmide TO CLISM_all;


--
-- Name: caractere_souche; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE caractere_souche FROM PUBLIC;
REVOKE ALL ON TABLE caractere_souche FROM CLISM;
GRANT ALL ON TABLE caractere_souche TO CLISM;
GRANT SELECT ON TABLE caractere_souche TO CLISM_all;


--
-- Name: caracterea; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE caracterea FROM PUBLIC;
REVOKE ALL ON TABLE caracterea FROM CLISM;
GRANT ALL ON TABLE caracterea TO CLISM;
GRANT SELECT ON TABLE caracterea TO CLISM_all;


--
-- Name: caracterea_souche; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE caracterea_souche FROM PUBLIC;
REVOKE ALL ON TABLE caracterea_souche FROM CLISM;
GRANT ALL ON TABLE caracterea_souche TO CLISM;
GRANT SELECT ON TABLE caracterea_souche TO CLISM_all;


--
-- Name: caracterep; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE caracterep FROM PUBLIC;
REVOKE ALL ON TABLE caracterep FROM CLISM;
GRANT ALL ON TABLE caracterep TO CLISM;
GRANT SELECT ON TABLE caracterep TO CLISM_all;


--
-- Name: clism_counters; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE clism_counters FROM PUBLIC;
REVOKE ALL ON TABLE clism_counters FROM CLISM;
GRANT ALL ON TABLE clism_counters TO CLISM;
GRANT SELECT ON TABLE clism_counters TO CLISM_all;


--
-- Name: editeur; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE editeur FROM PUBLIC;
REVOKE ALL ON TABLE editeur FROM CLISM;
GRANT ALL ON TABLE editeur TO CLISM;
GRANT SELECT ON TABLE editeur TO CLISM_all;


--
-- Name: espece; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE espece FROM PUBLIC;
REVOKE ALL ON TABLE espece FROM CLISM;
GRANT ALL ON TABLE espece TO CLISM;
GRANT SELECT ON TABLE espece TO CLISM_all;


--
-- Name: fragment; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE fragment FROM PUBLIC;
REVOKE ALL ON TABLE fragment FROM CLISM;
GRANT ALL ON TABLE fragment TO CLISM;
GRANT SELECT ON TABLE fragment TO CLISM_all;


--
-- Name: gene; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE gene FROM PUBLIC;
REVOKE ALL ON TABLE gene FROM CLISM;
GRANT ALL ON TABLE gene TO CLISM;
GRANT SELECT ON TABLE gene TO CLISM_all;


--
-- Name: gene_plasmide; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE gene_plasmide FROM PUBLIC;
REVOKE ALL ON TABLE gene_plasmide FROM CLISM;
GRANT ALL ON TABLE gene_plasmide TO CLISM;
GRANT SELECT ON TABLE gene_plasmide TO CLISM_all;


--
-- Name: gene_souche; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE gene_souche FROM PUBLIC;
REVOKE ALL ON TABLE gene_souche FROM CLISM;
GRANT ALL ON TABLE gene_souche TO CLISM;
GRANT SELECT ON TABLE gene_souche TO CLISM_all;


--
-- Name: nom_plasmide; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE nom_plasmide FROM PUBLIC;
REVOKE ALL ON TABLE nom_plasmide FROM CLISM;
GRANT ALL ON TABLE nom_plasmide TO CLISM;
GRANT SELECT ON TABLE nom_plasmide TO CLISM_all;


--
-- Name: nom_souche; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE nom_souche FROM PUBLIC;
REVOKE ALL ON TABLE nom_souche FROM CLISM;
GRANT ALL ON TABLE nom_souche TO CLISM;
GRANT SELECT ON TABLE nom_souche TO CLISM_all;


--
-- Name: phenotypeconfere; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE phenotypeconfere FROM PUBLIC;
REVOKE ALL ON TABLE phenotypeconfere FROM CLISM;
GRANT ALL ON TABLE phenotypeconfere TO CLISM;
GRANT SELECT ON TABLE phenotypeconfere TO CLISM_all;


--
-- Name: plasmide; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE plasmide FROM PUBLIC;
REVOKE ALL ON TABLE plasmide FROM CLISM;
GRANT ALL ON TABLE plasmide TO CLISM;
GRANT SELECT ON TABLE plasmide TO CLISM_all;


--
-- Name: plasmide_souche; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE plasmide_souche FROM PUBLIC;
REVOKE ALL ON TABLE plasmide_souche FROM CLISM;
GRANT ALL ON TABLE plasmide_souche TO CLISM;
GRANT SELECT ON TABLE plasmide_souche TO CLISM_all;


--
-- Name: revue; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE revue FROM PUBLIC;
REVOKE ALL ON TABLE revue FROM CLISM;
GRANT ALL ON TABLE revue TO CLISM;
GRANT SELECT ON TABLE revue TO CLISM_all;


--
-- Name: siterestriction; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE siterestriction FROM PUBLIC;
REVOKE ALL ON TABLE siterestriction FROM CLISM;
GRANT ALL ON TABLE siterestriction TO CLISM;
GRANT SELECT ON TABLE siterestriction TO CLISM_all;


--
-- Name: souche; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE souche FROM PUBLIC;
REVOKE ALL ON TABLE souche FROM CLISM;
GRANT ALL ON TABLE souche TO CLISM;
GRANT SELECT ON TABLE souche TO CLISM_all;


--
-- Name: transposon; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE transposon FROM PUBLIC;
REVOKE ALL ON TABLE transposon FROM CLISM;
GRANT ALL ON TABLE transposon TO CLISM;
GRANT SELECT ON TABLE transposon TO CLISM_all;


--
-- Name: transposon_plasmide; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE transposon_plasmide FROM PUBLIC;
REVOKE ALL ON TABLE transposon_plasmide FROM CLISM;
GRANT ALL ON TABLE transposon_plasmide TO CLISM;
GRANT SELECT ON TABLE transposon_plasmide TO CLISM_all;


--
-- Name: transposon_souche; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE transposon_souche FROM PUBLIC;
REVOKE ALL ON TABLE transposon_souche FROM CLISM;
GRANT ALL ON TABLE transposon_souche TO CLISM;
GRANT SELECT ON TABLE transposon_souche TO CLISM_all;


--
-- Name: utilisateur; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE utilisateur FROM PUBLIC;
REVOKE ALL ON TABLE utilisateur FROM CLISM;
GRANT ALL ON TABLE utilisateur TO CLISM;
GRANT SELECT ON TABLE utilisateur TO CLISM_all;


--
-- Name: vecteur; Type: ACL; Schema: public; Owner: CLISM
--

REVOKE ALL ON TABLE vecteur FROM PUBLIC;
REVOKE ALL ON TABLE vecteur FROM CLISM;
GRANT ALL ON TABLE vecteur TO CLISM;
GRANT SELECT ON TABLE vecteur TO CLISM_all;


--
-- PostgreSQL database dump complete
--

