
/*
Copyright INRA/CNRS

Emmanuel.Courcelle@toulouse.inra.fr
sebastien.carrere@toulouse.inra.fr

This software is a computer program whose purpose is to provide a
web-based interface for managing strains and plasmids in the LIPM

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can  use,
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info".

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability.

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or
data to be ensured and,  more generally, to use and operate it in the
same conditions as regards security.

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.
*/


/*

=pod

=head1 NAME
 clism.js - Global objects for index_xx.pl

=cut
*/


/* TODO VIRER CETTE FONCTION */
function affichage_popup(nom_de_la_page, nom_interne_de_la_fenetre)
{
	window.open (nom_de_la_page, nom_interne_de_la_fenetre, config='height=100, width=400, toolbar=no, menubar=no, scrollbars=no, resizable=no, location=no, directories=no, status=no')
}

/*
=head2 InitAutoComplete

	Title: InitAutoComplete
	Usage: InitAutoComplete(o_led)
	Procedure: Initialise les champs autocomplete de la page courante
	           Les champs autocomplete appartiennent tous a la classe AutocompleteClass ou a la classe AutocompleteEditClass
	Args:      o_led         = un objet LipmLed 
	Globals:   O_PARAM (pour reprendre le login)

=cut
*/

function InitAutocomplete(o_led)
{
	$$('.AutocompleteClass, .AutocompleteEditClass').each(function(e_field) {
			var o_ajax_data = new LipmAjaxDataClass(undefined,o_led);
			var field_name  = e_field.identify().gsub('ID_AC_','');
			//alert('coucou ' + field_name + ' ' + e_field.down('input').identify() + ' ' + e_field.down('div').identify() + ' ' + e_field.down().identify());
			//alert('coucou ' + field_name + ' ' + e_field.down().identify()+ ' ' + e_field.down().next().identify());
			var nom_info    = '&__wb_nom='+O_PARAM.__wb_nom;
			var login_info  = '';
			if (O_PARAM.__wb_login != undefined)
			{
				login_info = '&__wb_login='+O_PARAM.__wb_login;
			}
			o_ajax_data.SubmitAjax('__wb_function=AutocompleteFunction&__wb_autocomplete_field='+field_name+login_info+nom_info,function(response){
					//alert ('coucou ' + field_name + ' ' + e_field.down('input').identify() + ' ' + e_field.down('div').identify() + ' ' + e_field.down().identify() );
					var a_data = o_ajax_data.GetData();
					var o_data_source  = new YAHOO.widget.DS_JSArray( a_data );
					o_data_source.queryMatchContains = true;
					// ce qui suit ne marche pas sous ff 3.5, d'ou la ligne suivante
					//var o_auto_complete= new YAHOO.widget.AutoComplete(e_field.down('input').identify(),e_field.down('div').identify(),o_data_source);
					var o_auto_complete= new YAHOO.widget.AutoComplete(e_field.down().identify(),e_field.down().next().identify(),o_data_source);
					if (e_field.hasClassName('AutocompleteClass')){o_auto_complete.forceSelection = true};
					if (e_field.hasClassName('AutocompleteEditClass')){o_auto_complete.forceSelection = false};
			});
	});
}

function Load()
{
	var form = $$('form')[0];
	var o_led= new LipmLedClass('ID_LED');

	InitAutocomplete(o_led);
	if ($('ID_RESULTS') != null)
	{
		var o_results = new LipmPopupSimpleClass('ID_RESULTS');
		////o_results.Close();
		//var o_error = 
		var o_ajax = new LipmAjaxFormClass(form,o_results,undefined,o_led);
		Event.observe('ID_SUBMIT1','click',function(e){o_ajax.SubmitAjax(undefined,undefined,MapPopupObserver);e.stop();});
		Event.observe('ID_SUBMIT2','click',function(e){o_ajax.SubmitAjax(undefined,undefined,MapPopupObserver);e.stop();});
		InitForm(form,O_PARAM);
		
		new LipmFullScreenClass('ID_FULL_SCREEN','HideOnFullScreen');
		
		var o_new_win = new LipmPopupNewWindowClass('MapPopup',{
				scrollbars: true,
				height: 600,
				width: 700
		});
		
		// Fonction appelee a la fin des requetes Ajax ci-dessus, permet d'ouvrir dans un popup tout ce qui appartient a la classe MapPopup
		function MapPopupObserver()
		{
			o_new_win.Observe('ID_RESULT');
		}
	}
}

Event.observe(window,'load',Load);

